--   Copyright 1995, Intermetrics, Inc.
--
-- $Source: /home/dsd/d/aa/monoBANK/AA/j_ada.strings.unbounded.spc,v $ 
-- $Revision: 1.1 $ $Date: 96/08/15 21:29:18 $ $Author: vdelvecc $ 
--        Copyright (C) 1995 by Intermetrics, Inc.

pragma Suppress( Elaboration_Check );

with Ada.Strings.Maps;
with java.lang.StringBuffer;
package Ada.Strings.Unbounded is
    pragma Preelaborate (Unbounded);

    type Unbounded_String is private;

    Null_Unbounded_String : constant Unbounded_String;

    function Length (Source : Unbounded_String) return Natural;

    type String_Access is access all String;
    procedure Free (X : in out String_Access);
   
 -- Conversion, Concatenation, and Selection functions

    function To_Unbounded_String (Source : String)     
       return Unbounded_String;
    function To_Unbounded_String (Length : in Natural) 
       return Unbounded_String;

    function To_String (Source : Unbounded_String) return String;

    procedure Append (Source   : in out Unbounded_String;
                      New_Item : in Unbounded_String);

    procedure Append (Source   : in out Unbounded_String;
                      New_Item : in String);

    procedure Append (Source   : in out Unbounded_String;
                      New_Item : in Character);

    function amp_ubs_ubs (Left, Right : Unbounded_String) return Unbounded_String;
    function "&" (Left, Right : Unbounded_String) return Unbounded_String renames amp_ubs_ubs;

    function amp_ubs_str (Left  : in Unbounded_String; Right : in String)
       return  Unbounded_String;
    function "&" (Left  : in Unbounded_String; Right : in String)
       return  Unbounded_String renames amp_ubs_str;

    function amp_str_ubs (Left  : in String; Right : in Unbounded_String)
       return  Unbounded_String;
    function "&" (Left  : in String; Right : in Unbounded_String)
       return  Unbounded_String renames amp_str_ubs;

    function amp_ubs_ch (Left  : in Unbounded_String; Right : in Character)
       return  Unbounded_String;
    function "&" (Left  : in Unbounded_String; Right : in Character)
       return  Unbounded_String renames amp_ubs_ch;

    function amp_ch_ubs (Left  : in Character; Right : in Unbounded_String)
       return  Unbounded_String;
    function "&" (Left  : in Character; Right : in Unbounded_String)
       return  Unbounded_String renames amp_ch_ubs;

    function Element (Source : in Unbounded_String;
                      Index  : in Positive)
       return   Character;

    procedure Replace_Element (Source : in out Unbounded_String;
                               Index  : in Positive;
                               By     : Character);

    function Slice (Source : in Unbounded_String;
                    Low    : in Positive;
                    High   : in Natural)
       return   String;

    function eq_ubs_ubs (Left, Right : in Unbounded_String) return Boolean;
    function "=" (Left, Right : in Unbounded_String) return Boolean renames eq_ubs_ubs;

    function eq_ubs_str (Left  : in Unbounded_String; Right : in String)
       return  Boolean;
    function "=" (Left  : in Unbounded_String; Right : in String)
       return  Boolean renames eq_ubs_str;

    function eq_str_ubs (Left  : in String; Right : in Unbounded_String)
       return  Boolean;
    function "=" (Left  : in String; Right : in Unbounded_String)
       return  Boolean renames eq_str_ubs;

    function lt_ubs_ubs (Left, Right : in Unbounded_String) return Boolean;
    function "<" (Left, Right : in Unbounded_String) return Boolean renames lt_ubs_ubs;

    function lt_ubs_str (Left  : in Unbounded_String; Right : in String)
       return  Boolean;
    function "<" (Left  : in Unbounded_String; Right : in String)
       return  Boolean renames lt_ubs_str;

    function lt_str_ubs (Left  : in String; Right : in Unbounded_String)
       return  Boolean;
    function "<" (Left  : in String; Right : in Unbounded_String)
       return  Boolean renames lt_str_ubs;

    function le_ubs_ubs (Left, Right : in Unbounded_String) return Boolean;
    function "<=" (Left, Right : in Unbounded_String) return Boolean renames le_ubs_ubs;

    function le_ubs_str (Left  : in Unbounded_String; Right : in String)
       return  Boolean;
    function "<=" (Left  : in Unbounded_String; Right : in String)
       return  Boolean renames le_ubs_str;

    function le_str_ubs (Left  : in String; Right : in Unbounded_String)
       return  Boolean;
    function "<=" (Left  : in String; Right : in Unbounded_String)
       return  Boolean renames le_str_ubs;

    function gt_ubs_ubs (Left, Right : in Unbounded_String) return Boolean;
    function ">" (Left, Right : in Unbounded_String) return Boolean renames gt_ubs_ubs;

    function gt_ubs_str (Left  : in Unbounded_String; Right : in String)
       return  Boolean;
    function ">" (Left  : in Unbounded_String; Right : in String)
       return  Boolean renames gt_ubs_str;

    function gt_str_ubs (Left  : in String; Right : in Unbounded_String)
       return  Boolean;
    function ">" (Left  : in String; Right : in Unbounded_String)
       return  Boolean renames gt_str_ubs;

    function ge_ubs_ubs (Left, Right : in Unbounded_String) return Boolean;
    function ">=" (Left, Right : in Unbounded_String) return Boolean renames ge_ubs_ubs;

    function ge_ubs_str (Left  : in Unbounded_String; Right : in String)
       return  Boolean;
    function ">=" (Left  : in Unbounded_String; Right : in String)
       return  Boolean renames ge_ubs_str;

    function ge_str_ubs (Left  : in String; Right : in Unbounded_String)
       return  Boolean;
    function ">=" (Left  : in String; Right : in Unbounded_String)
       return  Boolean renames ge_str_ubs;

 -- Search subprograms

    function Index (Source   : in Unbounded_String;
Pattern : String)
--                    Pattern  : in String;
--                    Going    : in Direction := Forward;
--                    Mapping  : in Maps.Character_Mapping 
--				 := Maps.Identity)
       return     Natural;

    function Index (Source : in Unbounded_String;
                    Set    : in Maps.Character_Set;
                    Test   : in Membership := Inside;
                    Going  : in Direction  := Forward)
       return   Natural;

    function Index_Non_Blank (Source : in Unbounded_String;
                              Going  : in Direction := Forward)
       return   Natural;

    function Count (Source  : in Unbounded_String;
                    Pattern : in String;
                    Mapping : in Maps.Character_Mapping 
				:= Maps.Identity)
       return    Natural;

    function Count (Source : in Unbounded_String;
                    Set    : in Maps.Character_Set)
       return   Natural;

    procedure Find_Token (Source : in Unbounded_String;
                          Set    : in Maps.Character_Set;
                          Test   : in Membership;
                          First  : out Positive;
                          Last   : out Natural);

 -- String translation subprograms

    function Translate (Source  : in Unbounded_String;
                        Mapping : in Maps.Character_Mapping)
       return    Unbounded_String;

    procedure Translate (Source  : in out Unbounded_String;
                         Mapping : Maps.Character_Mapping);

 -- String transformation subprograms

    function Replace_Slice (Source : in Unbounded_String;
                            Low    : in Positive;
                            High   : in Natural;
                            By     : in String)
       return   Unbounded_String;

    procedure Replace_Slice (Source   : in out Unbounded_String;
                             Low      : in Positive;
                             High     : in Natural;
                             By       : in String);

    function Insert (Source   : in Unbounded_String;
                     Before   : in Positive;
                     New_Item : in String)
       return     Unbounded_String;

    procedure Insert (Source   : in out Unbounded_String;
                      Before   : in Positive;
                      New_Item : in String);

    function Overwrite (Source   : in Unbounded_String;
                        Position : in Positive;
                        New_Item : in String)
       return     Unbounded_String;

    procedure Overwrite (Source    : in out Unbounded_String;
                         Position  : in Positive;
                         New_Item  : in String);

    function Delete (Source  : in Unbounded_String;
                     From    : in Positive;
                     Through : in Natural)
       return    Unbounded_String;

    procedure Delete (Source  : in out Unbounded_String;
                      From    : in Positive;
                      Through : in Natural);

    function Trim (Source : in Unbounded_String;
                   Side   : in Trim_End)
       return   Unbounded_String;

    procedure Trim (Source : in out Unbounded_String;
                    Side   : in Trim_End);

    function Trim (Source : in Unbounded_String;
                   Left   : in Maps.Character_Set;
                   Right  : in Maps.Character_Set)
       return   Unbounded_String;

    procedure Trim (Source : in out Unbounded_String;
                    Left   : in Maps.Character_Set;
                    Right  : in Maps.Character_Set);

    function Head (Source : in Unbounded_String;
                   Count  : in Natural;
                   Pad    : in Character := Space)
       return   Unbounded_String;

    procedure Head (Source : in out Unbounded_String;
                    Count  : in Natural;
                    Pad    : in Character := Space);

    function Tail (Source : in Unbounded_String;
                   Count  : in Natural;
                   Pad    : in Character := Space)
       return   Unbounded_String;

    procedure Tail (Source : in out Unbounded_String;
                    Count  : in Natural;
                    Pad    : in Character := Space);

    function mult_ch (Left  : in Natural;
	              Right : in Character)
       return  Unbounded_String;
    function "*" (Left  : in Natural;
                  Right : in Character)
       return  Unbounded_String renames mult_ch;

    function mult_str (Left  : in Natural;
	               Right : in String)
       return  Unbounded_String;
    function "*" (Left  : in Natural;
                  Right : in String)
       return  Unbounded_String renames mult_str;

    function mult_ubs (Left  : in Natural;
	               Right : in Unbounded_String)
       return  Unbounded_String;
    function "*" (Left  : in Natural;
                  Right : in Unbounded_String)
       return  Unbounded_String renames mult_ubs;

private

    type Unbounded_String is
	access all java.lang.StringBuffer.StringBuffer_Obj;

    Null_Unbounded_String : constant Unbounded_String := null;

end Ada.Strings.Unbounded;

