-- $Source: /home/dsd/d/aa/monoBANK/AA/ada.calendar.tgt.spc,v $ 
-- $Revision: 1.3 $ $Date: 95/10/10 14:04:01 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   
package Ada.Calendar.TGT is

    -- This target dependent package provides the routines
    -- to support package Ada.Calendar.

    function GMT_Clock return Time;
    -- Returns GMT time in Calendar.Time format;
    -- The GMT_Clock value is returned unchanged by Calendar.Clock.
    -- If the GMT_Clock needs initialization, it could be done
    -- by the package body elaboration.

    function Local_Time_Zone return Duration;
    -- Returns number of seconds difference between local time and GMT.
    -- This value is subtracted from GMT to convert to local,
    -- and is added to local to convert to GMT, so it should be
    -- positive for time zones west of GMT up to the international
    -- date line (true of all time zones in the USA).
    -- This value is a function so that it may be changed while a
    -- program is executing.
    -- Because Calendar.Time is always GMT, changing the time zone
    -- should not affect Calendar.Clock nor active timers based
    -- on Ada.Calendar.Time.
    -- How a user program changes the local time zone, or even whether
    -- such a change is supported, is not specified by either the LRM
    -- or this interface.

end Ada.Calendar.TGT;
