-- $Source: /home/dsd/d/aa/monoBANK/AA/ada.numerics.aux.spc,v $ 
-- $Revision: 1.2 $ $Date: 96/09/18 13:46:30 $ $Author: stt $ 

-- Derived from:
------------------------------------------------------------------------------
--                                                                          --
--                         GNAT RUNTIME COMPONENTS                          --
--                                                                          --
--                     A D A . N U M E R I C S . A U X                      --
--                                                                          --
--                                 S p e c                                  --
--                           (C Library Version)                            --
--                                                                          --
--                            $Revision: 1.2 $                              --
--                                                                          --
--        Copyright (C) 1992,1993,1994 Free Software Foundation, Inc.       --
--                                                                          --
-- GNAT is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  GNAT is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with GNAT;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- GNAT was originally developed  by the GNAT team at  New York University. --
-- It is now maintained by Ada Core Technologies Inc (http://www.gnat.com). --
------------------------------------------------------------------------------

--  This package provides the elementary functions required by generic
--  complex types.  These could be implemented by importing from
--  some hardware library.  Here we just export routines from the
--  (Long_)Elementary_Functions package.

with Ada.Numerics.Long_Elementary_Functions;  -- implementation dependent
package Ada.Numerics.Aux is
pragma Pure (Aux);

   subtype Double is Long_Float; -- implementation dependent

   package EF renames Ada.Numerics.Long_Elementary_Functions;
                                 -- implementation dependent

   function Sin (X : Double) return Double renames EF.Sin;

   function Cos (X : Double) return Double renames EF.Cos;

   function Sqrt (X : Double) return Double renames EF.Sqrt;

   function Atan (X : Double; Y : Double := 1.0) return Double 
     renames EF.Arctan;
       -- Defaulted parameter is just there so that rename matches original
       -- It may be removed if implementing using some hardware library.

end Ada.Numerics.Aux;
