-- $Source: /home/dsd/d/aa/monoBANK/AA/j_ada.strings.unbounded.bdy,v $ 
-- $Revision: 1.1 $ $Date: 96/08/15 14:53:17 $ $Author: jparadis $ 
--        Copyright (C) 1995 by Intermetrics, Inc.

with Interfaces.Java; use Interfaces.Java;
with java.lang.String; use java.lang.String;
with Ada.Characters.Handling; use Ada.Characters.Handling;
package body Ada.Strings.Unbounded is
    pragma Suppress( Elaboration_Check );

    use java.lang.StringBuffer;

    subtype StringBuffer is StringBuffer_Obj;
    subtype ubs is Unbounded_String;
    function ubsLength(Source : Unbounded_String) return Natural
	renames Length;

    type Buffer_Access is access all StringBuffer;

    procedure raise_Index_Error is begin null; end;

    function Length (Source : Unbounded_String) return Natural is
    begin
	if Buffer_Access(Source) = null then
	    return 0;
	else
	    return java.lang.StringBuffer.length(source);
	end if;
    end Length;

--    procedure Deallocate is new Ada.Unchecked_Deallocation (String,
--							    String_Access);

    procedure Free (X : in out String_Access) is
    begin
	null;
--        Deallocate(X);
    end Free;

    function To_Unbounded_String (Source : String) return 
						Unbounded_String is
    begin
	return  Unbounded_String(
			new_StringBuffer( Ada_to_Java_String(Source)));
    end To_Unbounded_String;

    function To_Unbounded_String (Length : in Natural) return
						 Unbounded_String is
    begin
	return Unbounded_string( new_StringBuffer(length));
    end To_Unbounded_String;

    function To_Java_String(Source : Unbounded_String) return 
						 Java_String is
    begin
	if Buffer_Access(Source) = null then
	    return +"";
	else
	    return toString(Source);
	end if;
    end To_Java_String;

    function To_String (Source : Unbounded_String) return String is
    begin
	return Java_To_Ada_String(To_Java_String(Source));
    end To_String;

    procedure Append (Source   : in out Unbounded_String;
                      New_Item : in Unbounded_String) is
    begin
	if Buffer_Access(Source) = null then
	    Source := new StringBuffer;
     	    Source := Unbounded_String(new_StringBuffer(
					To_Java_String(New_Item)));
	else
	    Source := ubs(append(Source, To_Java_String(New_Item)));
	end if;
    end Append;

    procedure Append (Source   : in out Unbounded_String;
                      New_Item : in String) is
    begin
	if Buffer_Access(Source) = null then
	    Source := Unbounded_String(new_StringBuffer(
				Ada_To_Java_String(New_Item)));
	else
	    Source := ubs(append(Source, Ada_To_Java_String(New_Item)));
	end if;
    end Append;

    procedure Append (Source   : in out Unbounded_String;
                      New_Item : in Character) is
	
    begin
	Source := ubs(append(Source, To_Wide_Character(New_Item)));
    end Append;

    function Copy(Source : Unbounded_String)
       return Unbounded_String is
    begin
	return Unbounded_String(new_StringBuffer(
					To_Java_String(Source)));
    end Copy;

--    function "&" (Left, Right : Unbounded_String)
    function amp_ubs_ubs (Left, Right : Unbounded_String)
       return Unbounded_String is
        Result : Unbounded_String;
    begin
	return ubs(append(Copy(Left), To_Java_String(Right)));
    end;
--    end "&";

--    function "&" (Left : Unbounded_String; Right : String)
    function amp_ubs_str (Left : Unbounded_String; Right : String)
       return Unbounded_String is
	Result : Unbounded_String;
    begin
	return ubs(append(Copy(Left), Ada_To_Java_String(Right)));
    end;
--    end "&";

--    function "&" (Left : String; Right : Unbounded_String)
    function amp_str_ubs (Left : String; Right : Unbounded_String)
       return Unbounded_String is
    begin
	return ubs(append(To_Unbounded_String(Left), To_Java_String(Right)));
    end;
--    end "&";

--    function "&" (Left : Unbounded_String; Right : Character)
    function amp_ubs_ch (Left : Unbounded_String; Right : Character)
       return Unbounded_String is
       -- The following suppress is necessary because the check that
       -- the compiler emits for Wide_Character'Val is broken.
       pragma Suppress(Range_Check);
    begin
      return ubs(append(Copy(Left),
                        Wide_Character'Val(Character'Pos(Right))));
    end;
--    end "&";

--    function "&" (Left : Character; Right : Unbounded_String)
    function amp_ch_ubs (Left : Character; Right : Unbounded_String)
       return Unbounded_String is
    begin
	return String'(1 => Left) & Right;
    end;
--    end "&";

    function Element (Source : Unbounded_String;
                      Index  : Positive)
       return Character is
    begin
        if Buffer_Access(Source) /= null and then
	  Index <= ubsLength(Source) then
            return To_Character(charAt(Source, Index - 1));
        else
            raise_Index_Error;
	    return ' ';
        end if;
    end Element;

    procedure Replace_Element (Source : in out Unbounded_String;
                               Index  : Positive;
                               By     : Character) is
    begin
        if Buffer_Access(Source) /= null and then
	  Index <= ubsLength(Source) then
	    setCharAt(Source, Index - 1, To_Wide_Character(By));
        else
            raise_Index_Error;
        end if;
    end Replace_Element;

    function Slice (Source : Unbounded_String;
                    Low    : Positive;
                    High   : Natural)
       return String is
    begin
        if Low > ubsLength(Source) + 1 or else High > ubsLength(Source) then 
            raise_Index_Error;
	    return "";
        else
	    declare
		Result : Wide_String(Low .. High);
	    begin
		if Low <= High then
		    getChars(Source, Low - 1, High, Result, 0);
		end if;
		return To_String(Result);
	    end;
        end if;
    end Slice;

--    function "=" (Left, Right : in Unbounded_String) return Boolean is
    function eq_ubs_ubs (Left, Right : in Unbounded_String) return Boolean is
    begin
	return "="(To_Java_String(Left), To_Java_String(Right));
    end;
--    end "=";

--    function "=" (Left : in Unbounded_String; Right : in String)
    function eq_ubs_str (Left : in Unbounded_String; Right : in String)
       return Boolean is
    begin
	return "="(To_Java_String(Left),
		  Ada_To_Java_String(Right));
    end;
--    end "=";

--    function "=" (Left : in String; Right : in Unbounded_String)
    function eq_str_ubs (Left : in String; Right : in Unbounded_String)
       return Boolean is
    begin
	return "="(Ada_To_Java_String(Left),
		      To_Java_String(Right));
    end;
--    end "=";

--    function "<" (Left, Right : in Unbounded_String) return Boolean is
    function lt_ubs_ubs (Left, Right : in Unbounded_String) return Boolean is
    begin
	return compareTo(To_Java_String(Left), To_Java_String(Right)) < 0;
    end;
--    end "<";

--    function "<" (Left : in Unbounded_String; Right : in String)
    function lt_ubs_str (Left : in Unbounded_String; Right : in String)
       return Boolean is
    begin
	return compareTo(To_Java_String(Left), Ada_To_Java_String(Right)) < 0;
    end;
--    end "<";

--    function "<" (Left : in String; Right : in Unbounded_String)
    function lt_str_ubs (Left : in String; Right : in Unbounded_String)
       return Boolean is
    begin
	return compareTo(Ada_To_Java_String(Left), To_Java_String(Right)) < 0;
    end;
--    end "<";

--    function "<=" (Left, Right : in Unbounded_String) return Boolean is
    function le_ubs_ubs (Left, Right : in Unbounded_String) return Boolean is
    begin
	return compareTo(To_Java_String(Left), To_Java_String(Right)) <= 0;
    end;
--    end "<=";

--    function "<=" (Left : in Unbounded_String; Right : in String)
    function le_ubs_str (Left : in Unbounded_String; Right : in String)
       return Boolean is
    begin
	return compareTo(To_Java_String(Left), Ada_To_Java_String(Right)) <= 0;
    end;
--    end "<=";

--    function "<=" (Left : in String; Right : in Unbounded_String)
    function le_str_ubs (Left : in String; Right : in Unbounded_String)
       return Boolean is
    begin
	return compareTo(Ada_To_Java_String(Left), To_Java_String(Right)) <= 0;
    end;
--    end "<=";

--    function ">" (Left, Right : in Unbounded_String) return Boolean is
    function gt_ubs_ubs (Left, Right : in Unbounded_String) return Boolean is
    begin
	return compareTo(To_Java_String(Left), To_Java_String(Right)) > 0;
    end;
--    end ">";

--    function ">" (Left : in Unbounded_String; Right : in String)
    function gt_ubs_str (Left : in Unbounded_String; Right : in String)
       return Boolean is
    begin
	return compareTo(To_Java_String(Left), Ada_To_Java_String(Right)) > 0;
    end;
--    end ">";

--    function ">" (Left : in String; Right : in Unbounded_String)
    function gt_str_ubs (Left : in String; Right : in Unbounded_String)
       return Boolean is
    begin
	return compareTo(Ada_To_Java_String(Left), To_Java_String(Right)) > 0;
    end;
--    end ">";

--    function ">=" (Left, Right : in Unbounded_String) return Boolean is
    function ge_ubs_ubs (Left, Right : in Unbounded_String) return Boolean is
    begin
	return compareTo(To_Java_String(Left), To_Java_String(Right)) >= 0;
    end;
--    end ">=";

--    function ">=" (Left : in Unbounded_String; Right : in String)
    function ge_ubs_str (Left : in Unbounded_String; Right : in String)
       return Boolean is
    begin
	return compareTo(To_Java_String(Left), Ada_To_Java_String(Right)) >= 0;
    end;
--    end ">=";

--    function ">=" (Left : in String; Right : in Unbounded_String)
    function ge_str_ubs (Left : in String; Right : in Unbounded_String)
       return Boolean is
    begin
	return compareTo(Ada_To_Java_String(Left), To_Java_String(Right)) >= 0;
    end;
--    end ">=";

    function Index (Source   : Unbounded_String;
Pattern : String)
--                    Pattern  : String;
--                    Going    : Direction := Forward;
--                    Mapping  : Maps.Character_Mapping 
--                              := Maps.Identity)
       return Natural is
	S : String := To_String(Source);
    begin
	-- TBD: raise Pattern_Error if Pattern = ""
	for i in S'First .. S'Last - Pattern'Length + 1 loop
	    if S(i .. i + Pattern'Length - 1) = Pattern then
		return i;
	    end if;
	end loop;
	return 0;
--        return RSS.Index(Source.Str_Ptr.all, Pattern, Going, Mapping);
    end Index;

    function Index (Source : Unbounded_String;
                    Set    : Maps.Character_Set;
                    Test   : Membership := Inside;
                    Going  : Direction  := Forward)
       return Natural is
    begin
	return 0;
--        return RSS.Index(Source.Str_Ptr.all, Set, Test, Going);
    end Index;

    function Index_Non_Blank (Source : Unbounded_String;
                              Going  : Direction := Forward)
       return Natural is
    begin
	return 0;
--        return RSS.Index_Non_Blank(Source.Str_Ptr.all, Going);
    end Index_Non_Blank;

    function Count (Source   : Unbounded_String;
                    Pattern  : String;
                    Mapping  : Maps.Character_Mapping 
                              := Maps.Identity)
       return Natural is
    begin
	return 0;
--        return RSS.Count(Source.Str_Ptr.all, Pattern, Mapping);
    end Count;

    function Count (Source   : Unbounded_String;
                    Set      : Maps.Character_Set)
       return Natural is
    begin
	return 0;
--        return RSS.Count(Source.Str_Ptr.all, Set);
    end Count;

    procedure Find_Token (Source : Unbounded_String;
                          Set    : Maps.Character_Set;
                          Test   : Membership;
                          First  : out Positive;
                          Last   : out Natural) is
    begin
	null;
--        RSS.Find_Token(Source.Str_Ptr.all, Set, Test, First, Last);
    end Find_Token;

    function Translate (Source  : Unbounded_String;
                        Mapping : Maps.Character_Mapping)
       return Unbounded_String is
    begin
	return null;
--        return To_Unbounded_String(ASF.Translate(Source.Str_Ptr.all, Mapping));
    end Translate;

    procedure Translate (Source  : in out Unbounded_String;
                         Mapping : Maps.Character_Mapping) is
    begin
	null;
--        ASF.Translate(Source.Str_Ptr.all, Mapping);
    end Translate;

    function Replace_Slice (Source   : Unbounded_String;
                            Low      : Positive;
                            High     : Natural;
                            By       : String)
       return Unbounded_String is
    begin
	return null;
--        return To_Unbounded_String(ASF.Replace_Slice(Source.Str_Ptr.all,
--                                                     Low,
--						     High,
--						     By));
    end Replace_Slice;

    procedure Replace_Slice (Source   : in out Unbounded_String;
                             Low      : in Positive;
                             High     : in Natural;
                             By       : in String) is
--        New_String : String(1.. Source.Str_Ptr.all'Length) :=
--			 Source.Str_Ptr.all;
    begin
	null;
--	Deallocate(Source.Str_Ptr);
--        Source := To_Unbounded_String(ASF.Replace_Slice(New_String,
--							Low,
--							High,
--							By));
    end Replace_Slice;

    function Insert (Source   : Unbounded_String;
                     Before   : Positive;
                     New_Item : String)
       return Unbounded_String is
    begin
        if Before <= ubsLength(Source) + 1 then
	    return ubs(insert(Copy(Source), Before - 1,
			      Ada_To_Java_String(New_Item)));
	else
	    raise_Index_Error;
	    return null;
	end if;
    end Insert;

    procedure Insert (Source   : in out Unbounded_String;
                      Before   : in Positive;
                      New_Item : in String) is
    begin
        if Before <= ubsLength(Source) + 1 then
	    if Buffer_Access(Source) = null then
		Source := To_Unbounded_String(New_Item);
	    else
		Source := ubs(insert(Source, Before - 1,
				     Ada_To_Java_String(New_Item)));
	    end if;
	else
	    raise_Index_Error;
	end if;
    end Insert;

    function Overwrite (Source    : Unbounded_String;
                        Position  : Positive;
                        New_Item  : String)
       return Unbounded_String is
    begin
	return null;
--        return To_Unbounded_String(ASF.Overwrite(Source.Str_Ptr.all,
--						 Position,
--						 New_Item));
    end Overwrite;

    procedure Overwrite (Source    : in out Unbounded_String;
                         Position  : in Positive;
                         New_Item  : in String) is
--        New_String : String(1.. Source.Str_Ptr.all'Length) :=
--			 Source.Str_Ptr.all;
    begin
	null;
--	Deallocate(Source.Str_Ptr);
--        Source := To_Unbounded_String(ASF.Overwrite(New_String,
--						    Position,
--						    New_Item));
    end Overwrite;

    function Delete (Source  : Unbounded_String;
                     From    : Positive;
                     Through : Natural)
       return Unbounded_String is
    begin
	return null;
--        return To_Unbounded_String(ASF.Delete(Source.Str_Ptr.all,
--					      From,
--					      Through));
    end Delete;

    procedure Delete (Source  : in out Unbounded_String;
                      From    : in Positive;
                      Through : in Natural) is
--        New_String : String(1.. Source.Str_Ptr.all'Length) :=
--			 Source.Str_Ptr.all;
    begin
	null;
--	Deallocate(Source.Str_Ptr);
--        Source := To_Unbounded_String(ASF.Delete(New_String,
--						 From,
--						 Through));
   end Delete;

    function Trim (Source : in Unbounded_String;
                   Side   : in Trim_End)
       return Unbounded_String is
	S : String := To_String(Source);
	Low, High : Integer;
    begin
	Low := S'First;
	if Side = Left or else Side = Both then
	    while Low < S'Last and then S(Low) = ' ' loop
		Low := Low + 1;
	    end loop;
	end if;
	High := S'Last;
	if Side = Right or else Side = Both then
	    while High > S'First and then S(High) = ' ' loop
		High := High - 1;
	    end loop;
	end if;
	if Low > High then
	    return Copy(null);
	else
	    return Unbounded_String(new_StringBuffer(
		 substring(To_Java_String(Source), Low - 1, High)));
	end if;
    end Trim;

    procedure Trim (Source : in out Unbounded_String;
                    Side   : in Trim_End) is
    begin
	Source := Trim(Source, Side);
    end Trim;

    function Trim (Source : in Unbounded_String;
                   Left   : in Maps.Character_Set;
                   Right  : in Maps.Character_Set)
       return Unbounded_String is
    begin
	return null;
--        return To_Unbounded_String(ASF.Trim(Source.Str_Ptr.all, Left, Right));
    end Trim;

    procedure Trim (Source : in out Unbounded_String;
                    Left   : in Maps.Character_Set;
                    Right  : in Maps.Character_Set) is
--        New_String : String(1.. Source.Str_Ptr.all'Length) :=
--			 Source.Str_Ptr.all;
    begin
	null;
--	Deallocate(Source.Str_Ptr);
--        ASF.Trim (New_String, Left, Right);
    end Trim;

    function Head (Source : Unbounded_String;
                   Count  : Natural;
                   Pad    : Character := Space)
       return Unbounded_String is
	Result : Unbounded_String := Copy(Source);
    begin
	if ubsLength(Source) < Count then
--	    Append(Result, String'(ubsLength(Source) + 1 .. Count => Pad));
	    Append(Result,
		   Unbounded_String'((Count - ubsLength(Source)) * Pad));
	else
	    setLength(Result, Count);
	end if;
	return Result;
    end Head;

    procedure Head (Source : in out Unbounded_String;
                    Count  : in Natural;
                    Pad    : in Character := Space) is
    begin
	if ubsLength(Source) < Count then
--	    Append(Source, String'(ubsLength(Source) + 1 .. Count => Pad));
	    Append(Source,
		   Unbounded_String'((Count - ubsLength(Source)) * Pad));
	else
	    setLength(Source, Count);
	end if;
    end Head;

    function Tail (Source : Unbounded_String;
                   Count  : Natural;
                   Pad    : Character := Space)
       return Unbounded_String is
    begin
	if ubsLength(Source) < Count then
--	    Result :=
--	      ubs(insert(Copy(Source), 0,
--			 Ada_To_Java_String(
--			   (ubsLength(Source) + 1 .. Count => Pad))));
	    return  Unbounded_String'(
			(Count - ubsLength(Source)) * Pad) & Source;
	else
	    return Unbounded_String(new_StringBuffer(
		      substring(To_Java_String(Source),
				ubsLength(Source) - Count)));
	end if;
    end Tail;

    procedure Tail (Source : in out Unbounded_String;
                    Count  : in Natural;
                    Pad    : in Character := Space) is
    begin
	Source := Tail(Source, Count, Pad);
    end Tail;

--    function "*" (Left  : Natural;
    function mult_ch (Left  : Natural;
                  Right : Character)
       return Unbounded_String is
	String_Result : String(1..Left);
    begin
	for i in 1 .. Left loop
	    String_Result(i) := Right;
	end loop;
	return To_Unbounded_String(String_Result);
--	return To_Unbounded_String(String'(1 .. Left => Right));
    end;
--    end "*";

--    function "*" (Left  : Natural;
    function mult_str (Left  : Natural;
                  Right : String)
       return Unbounded_String is
	Java_Right : Java_String := Ada_To_Java_String(Right);
	Result : Unbounded_String := Copy(null);
    begin
	for i in 1 .. Left loop
	    Result := ubs(append(Result, Java_Right));
	end loop;
	return Result;
    end;
--    end "*";

--    function "*" (Left  : Natural;
    function mult_ubs (Left  : Natural;
                  Right : Unbounded_String)
       return Unbounded_String is
	Java_Right : Java_String := To_Java_String(Right);
	Result : Unbounded_String := Copy(null);
    begin
	for i in 2 .. Left loop
	    Result := ubs(append(Result, Java_Right));
	end loop;
	return Result;
    end;
--    end "*";

end Ada.Strings.Unbounded;
