-- $Source: /home/dsd/d/aa/monoBANK/AA/ada.task_attributes.spc,v $ 
-- $Revision: 1.4 $ $Date: 96/03/15 10:30:41 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

pragma Suppress( Elaboration_Check );

with Ada.Task_Identification; use Ada.Task_Identification;

pragma ada_child;
generic
    type Attribute is private;
    Initial_Value : in Attribute;
   
package Ada.Task_Attributes is
    pragma Suppress( Elaboration_Check );

       type Attribute_Handle is access all Attribute;
    
    function Value( T : Task_ID := Current_Task ) return Attribute;
    --*OVERVIEW
    -- The function Value returns the value of the corresponding
    -- attribute of T
    --*EFFECTS
    -- Tasking_Error is raised is T is terminated and Program_Error will
    -- be raised if T is null_task_Id
    
	
    function Reference( T : Task_ID := Current_Task )
    	    	    	    	    	    return Attribute_Handle;    
    --*OVERVIEW
    -- The function Reference returns an access value that designates
    -- the corresponding attribute of T
    --*EFFECTS
    -- Tasking_Error is raised is T is terminated and Program_Error will
    -- be raised if T is null_task_Id
    				    

    procedure Set_Value( Val : in Attribute;
    			 T   : in Task_ID := Current_Task );
    --*OVERVIEW
    --The procedure Set_Value performs any finalization on the old
    -- value of the attribute of T and assigns Val to that attribute
    --*EFFECTS
    -- Tasking_Error is raised is T is terminated and Program_Error will
    -- be raised if T is null_task_Id
    
			 
    procedure Reinitialize( T : in Task_ID := Current_Task );
    --*OVERVIEW
    -- The procedure Reinitiallize does the same as Set_Value where the
    -- Val parameter is replaced Initial_Value
    --*EFFECTS
    -- Tasking_Error is raised is T is terminated and Program_Error will
    -- be raised if T is null_task_Id

end Ada.Task_Attributes;
