-- $Source: /home/dsd/d/aa/monoBANK/AA/java_awt_Color.ada,v $ 
-- $Revision: 1.1 $ $Date: 96/08/26 17:24:50 $ $Author: vdelvecc $ 
with java.lang.String; use java.lang.String;
with java.lang; use java.lang;
package java.awt.Color is

    type Color_Obj is tagged limited null record;
    type Color_Ptr is access all Color_Obj;

    white : constant Color_Ptr;
    pragma Import(Java, white);

    lightGray : constant Color_Ptr;
    pragma Import(Java, lightGray);

    gray : constant Color_Ptr;
    pragma Import(Java, gray);

    darkGray : constant Color_Ptr;
    pragma Import(Java, darkGray);

    black : constant Color_Ptr;
    pragma Import(Java, black);

    red : constant Color_Ptr;
    pragma Import(Java, red);

    pink : constant Color_Ptr;
    pragma Import(Java, pink);

    orange : constant Color_Ptr;
    pragma Import(Java, orange);

    yellow : constant Color_Ptr;
    pragma Import(Java, yellow);

    green : constant Color_Ptr;
    pragma Import(Java, green);

    magenta : constant Color_Ptr;
    pragma Import(Java, magenta);

    cyan : constant Color_Ptr;
    pragma Import(Java, cyan);

    blue : constant Color_Ptr;
    pragma Import(Java, blue);

    function new_Color(
        r : Integer;
        g : Integer;
        b : Integer)
      return Color_Ptr;

    function new_Color(
        rgb : Integer)
      return Color_Ptr;

    function new_Color(
        r : Float;
        g : Float;
        b : Float)
      return Color_Ptr;

    function getRed(Obj : access Color_Obj) return Integer;

    function getGreen(Obj : access Color_Obj) return Integer;

    function getBlue(Obj : access Color_Obj) return Integer;

    function getRGB(Obj : access Color_Obj) return Integer;

    function brighter(Obj : access Color_Obj) return Color_Ptr;

    function darker(Obj : access Color_Obj) return Color_Ptr;

    function hashCode(Obj : access Color_Obj) return Integer;

    function "="(Left, Right : Color_Obj) return Boolean;
    pragma Import(Ada, "=", "equals");

    function toString(Obj : access Color_Obj) return String_Ptr;

    function getColor(
        nm : String_Ptr)
      return Color_Ptr;

    function getColor(
        nm : String_Ptr;
        v : Color_Ptr)
      return Color_Ptr;

    function getColor(
        nm : String_Ptr;
        v : Integer)
      return Color_Ptr;

    function HSBtoRGB(
        hue : Float;
        saturation : Float;
        brightness : Float)
      return Integer;

    type HSB_Array is array(1..3) of Float;
    type HSB_Array_Ptr is access all HSB_Array;

    function RGBtoHSB(
        r : Integer;
        g : Integer;
        b : Integer;
        hsbvals : HSB_Array_Ptr)
      return HSB_Array_Ptr;

    function getHSBColor(
        h : Float;
        s : Float;
        b : Float)
      return Color_Ptr;

    pragma Import(Java, darker);
    pragma Import(Java, getHSBColor);
    pragma Import(Java, getGreen);
    pragma Import(Java, HSBtoRGB);
    pragma Import(Java, RGBtoHSB);
    pragma Import(Java, hashCode);
    pragma Import(Java, getRed);
    pragma Import(Java, getRGB);
    pragma Import(Java, getBlue);
    pragma Import(Java, brighter);
    pragma Import(Java, toString);
    pragma Import(Java, getColor);

    pragma Import(Java_Constructor, new_Color);

end java.awt.Color;
