-- $Source: /home/dsd/d/aa/monoBANK/AA/java_awt_Container.ada,v $ 
-- $Revision: 1.1 $ $Date: 96/08/26 17:24:51 $ $Author: vdelvecc $ 
with java.lang; use java.lang;
with java.awt.Component; use java.awt.Component;
with java.lang.String; use java.lang.String;
-- with java.awt.LayoutManager; use java.awt.LayoutManager;
with java.awt.Event; use java.awt.Event;
with java.awt.Graphics; use java.awt.Graphics;
with java.awt.Dimension; use java.awt.Dimension;
with java.awt.Insets; use java.awt.Insets;
with java.io.PrintStream; use java.io.PrintStream;
package java.awt.Container is

    type Container_Obj is abstract new Component_Obj with null record;
    type Container_Ptr is access all Container_Obj'Class;

    function countComponents(Obj : access Container_Obj) return Integer;

    function getComponent(Obj : access Container_Obj;
        n : Integer)
      return Component_Ptr;

    type Component_Array is array(Positive range <>) of Component_Ptr;

    function getComponents(Obj : access Container_Obj) return Component_Array;

    function insets(Obj : access Container_Obj) return Insets_Ptr;

    function add(Obj : access Container_Obj;
        comp : Component_Ptr)
      return Component_Ptr;

    function add(Obj : access Container_Obj;
        comp : Component_Ptr;
        pos : Integer)
      return Component_Ptr;

    function add(Obj : access Container_Obj;
        name : String_Ptr;
        comp : Component_Ptr)
      return Component_Ptr;

    procedure remove(Obj : access Container_Obj;
        comp : Component_Ptr);

    procedure removeAll(Obj : access Container_Obj);

    procedure layout(Obj : access Container_Obj);

    procedure validate(Obj : access Container_Obj);

    function preferredSize(Obj : access Container_Obj) return Dimension_Ptr;

    function minimumSize(Obj : access Container_Obj) return Dimension_Ptr;

    procedure paintComponents(Obj : access Container_Obj;
        g : Graphics_Ptr);

    procedure printComponents(Obj : access Container_Obj;
        g : Graphics_Ptr);

    procedure deliverEvent(Obj : access Container_Obj;
        e : Event_Ptr);

    function locate(Obj : access Container_Obj;
        x : Integer;
        y : Integer)
      return Component_Ptr;

    procedure addNotify(Obj : access Container_Obj);

    procedure removeNotify(Obj : access Container_Obj);

    procedure list(Obj : access Container_Obj;
        stdout : PrintStream_Ptr;
        indent : Integer);

    -- This operation is from the class "Component";
    -- it have been moved here to avoid circularity
    function getParent(Obj : access Component_Obj'Class) return Container_Ptr;

    pragma Import(Java, minimumSize);
    pragma Import(Java, insets);
    pragma Import(Java, paintComponents);
    pragma Import(Java, removeNotify);
    pragma Import(Java, add);
    pragma Import(Java, addNotify);
    pragma Import(Java, countComponents);
    pragma Import(Java, remove);
    pragma Import(Java, validate);
    pragma Import(Java, getComponent);
    pragma Import(Java, deliverEvent);
    pragma Import(Java, removeAll);
    pragma Import(Java, locate);
    pragma Import(Java, preferredSize);
    pragma Import(Java, printComponents);
    pragma Import(Java, layout);
    pragma Import(Java, list);
    pragma Import(Java, getComponents);

    pragma Import(Java, getParent, "java/awt/Component.getParent");

end java.awt.Container;
