-- $Source: /home/dsd/d/aa/monoBANK/AA/java_lang_Object_ops.ada,v $ 
-- $Revision: 1.1 $ $Date: 96/08/26 17:28:50 $ $Author: vdelvecc $ 
with java.lang.String; use java.lang.String;
with java.lang.Class; use java.lang.Class;
package java.lang.Object_ops is

    -- This is logically a continuation of the java.lang.Object abstraction
    -- We separate it out to avoid running into circularity problems
    -- in Ada (since java.lang.String/Class both depend on Object)
    -- We also separate them out so they don't get inherited by
    -- all types, which could add undesirable baggage to every type

    function getClass(Obj : access Object'Class) return Class_Ptr;

    function toString(Obj : access Object'Class) return String_Ptr;
    function "="(Left: Object'Class; Right : Object'Class) return Boolean;

    procedure notify(Obj : access Object'Class);

    procedure notifyAll(Obj : access Object'Class);

    procedure wait(Obj : access Object'Class;
        timeout : Long_Integer);

    procedure wait(Obj : access Object'Class;
        timeout : Long_Integer;
        nanos : Integer);

    procedure wait(Obj : access Object'Class);

    pragma Import(Java, "=", "java/lang/Object.equals");
    pragma Import(Java, toString, "java/lang/Object.toString");
    pragma Import(Java, wait, "java/lang/Object.wait");
    pragma Import(Java, getClass, "java/lang/Object.getClass");
    pragma Import(Java, notifyAll, "java/lang/Object.notifyAll");
    pragma Import(Java, notify, "java/lang/Object.notify");


end java.lang.Object_ops;
