-- $Source: /home/dsd/d/aa/monoBANK/AA/java_awt_Rectangle.ada,v $ 
-- $Revision: 1.2 $ $Date: 96/10/31 16:04:09 $ $Author: stt $ 
with java.lang; use java.lang;
with java.lang.String; use java.lang.String;
with java.awt.Dimension; use java.awt.Dimension;
with java.awt.Point; use java.awt.Point;
package java.awt.Rectangle is

    type Rectangle_Obj is new Object with record
        x : Integer;
        y : Integer;
        width : Integer;
        height : Integer;
    end record;
    type Rectangle_Ptr is access all Rectangle_Obj'Class;

    function new_Rectangle(Obj : Rectangle_Ptr := null) return Rectangle_Ptr;

    function new_Rectangle(
        x : Integer;
        y : Integer;
        width : Integer;
        height : Integer;
        Obj : Rectangle_Ptr := null)
      return Rectangle_Ptr;

    function new_Rectangle(
        width : Integer;
        height : Integer;
        Obj : Rectangle_Ptr := null)
      return Rectangle_Ptr;

    function new_Rectangle(
        p : Point_Ptr;
        d : Dimension_Ptr;
        Obj : Rectangle_Ptr := null)
      return Rectangle_Ptr;

    function new_Rectangle(
        p : Point_Ptr;
        Obj : Rectangle_Ptr := null)
      return Rectangle_Ptr;

    function new_Rectangle(
        d : Dimension_Ptr;
        Obj : Rectangle_Ptr := null)
      return Rectangle_Ptr;

    procedure reshape(Obj : access Rectangle_Obj;
        x : Integer;
        y : Integer;
        width : Integer;
        height : Integer);

    procedure move(Obj : access Rectangle_Obj;
        x : Integer;
        y : Integer);

    procedure translate(Obj : access Rectangle_Obj;
        x : Integer;
        y : Integer);

    procedure resize(Obj : access Rectangle_Obj;
        width : Integer;
        height : Integer);

    function inside(Obj : access Rectangle_Obj;
        x : Integer;
        y : Integer)
      return Boolean;

    function intersects(Obj : access Rectangle_Obj;
        r : Rectangle_Ptr)
      return Boolean;

    function intersection(Obj : access Rectangle_Obj;
        r : Rectangle_Ptr)
      return Rectangle_Ptr;

    function union(Obj : access Rectangle_Obj;
        r : Rectangle_Ptr)
      return Rectangle_Ptr;

    procedure add(Obj : access Rectangle_Obj;
        newx : Integer;
        newy : Integer);

    procedure add(Obj : access Rectangle_Obj;
        pt : Point_Ptr);

    procedure add(Obj : access Rectangle_Obj;
        r : Rectangle_Ptr);

    procedure grow(Obj : access Rectangle_Obj;
        h : Integer;
        v : Integer);

    function isEmpty(Obj : access Rectangle_Obj) return Boolean;

    function hashCode(Obj : access Rectangle_Obj) return Integer;

    function "="(Left, Right : Rectangle_Obj) return Boolean;
    pragma Import(Ada, "=", "equals");

    function toString(Obj : access Rectangle_Obj) return String_Ptr;

    pragma Import(Java, move);
    pragma Import(Java, add);
    pragma Import(Java, union);
    pragma Import(Java, translate);
    pragma Import(Java, intersection);
    pragma Import(Java, reshape);
    pragma Import(Java, hashCode);
    pragma Import(Java, resize);
    pragma Import(Java, inside);
    pragma Import(Java, grow);
    pragma Import(Java, intersects);
    pragma Import(Java, isEmpty);
    pragma Import(Java, toString);

    pragma Import(Java_Constructor, new_Rectangle);

end java.awt.Rectangle;
