-- $Source: /home/dsd/d/aa/monoBANK/AA/java_lang_Runtime.ada,v $ 
-- $Revision: 1.1 $ $Date: 96/08/26 17:28:54 $ $Author: vdelvecc $ 
with java.lang; use java.lang;
with java.lang.String; use java.lang.String;
with java.io.OutputStream; use java.io.OutputStream;
with java.io.InputStream; use java.io.InputStream;
with java.lang.Process; use java.lang.Process;
package java.lang.Runtime is

    type Runtime_Obj is new Object with null record;
    type Runtime_Ptr is access all Runtime_Obj'Class;

    function getRuntime return Runtime_Ptr;

    procedure exit_program(Obj : access Runtime_Obj;
        status : Integer);

    function exec(Obj : access Runtime_Obj;
        command : String_Ptr)
      return Process_Ptr;

    function exec(Obj : access Runtime_Obj;
        command : String_Ptr;
        envp : String_Array)
      return Process_Ptr;

    function exec(Obj : access Runtime_Obj;
        cmdarray : String_Array)
      return Process_Ptr;

    function exec(Obj : access Runtime_Obj;
        cmdarray : String_Array;
        envp : String_Array)
      return Process_Ptr;

    function freeMemory(Obj : access Runtime_Obj) return Long_Integer;

    function totalMemory(Obj : access Runtime_Obj) return Long_Integer;

    procedure gc(Obj : access Runtime_Obj);

    procedure runFinalization(Obj : access Runtime_Obj);

    procedure traceInstructions(Obj : access Runtime_Obj;
        P1 : Boolean);

    procedure traceMethodCalls(Obj : access Runtime_Obj;
        P1 : Boolean);

    procedure load(Obj : access Runtime_Obj;
        filename : String_Ptr);

    procedure loadLibrary(Obj : access Runtime_Obj;
        libname : String_Ptr);

    function getLocalizedInputStream(Obj : access Runtime_Obj;
        stdin : InputStream_Ptr)
      return InputStream_Ptr;

    function getLocalizedOutputStream(Obj : access Runtime_Obj;
        stdout : OutputStream_Ptr)
      return OutputStream_Ptr;

    pragma Import(Java, getLocalizedInputStream);
    pragma Import(Java, totalMemory);
    pragma Import(Java, gc);
    pragma Import(Java, getLocalizedOutputStream);
    pragma Import(Java, traceMethodCalls);
    pragma Import(Java, getRuntime);
    pragma Import(Java, exec);
    pragma Import(Java, traceInstructions);
    pragma Import(Java, freeMemory);
    pragma Import(Java, load);
    pragma Import(Java, exit_program, "exit");
    pragma Import(Java, runFinalization);
    pragma Import(Java, loadLibrary);


end java.lang.Runtime;
