-- $Source: /home/dsd/d/aa/monoBANK/AA/java_lang_StringBuffer.ada,v $ 
-- $Revision: 1.2 $ $Date: 96/11/11 13:51:18 $ $Author: stt $ 
with java.lang; use java.lang;
with java.lang.String; use java.lang.String;
package java.lang.StringBuffer is
    pragma Preelaborate(StringBuffer);

    type StringBuffer_Obj is tagged limited null record;
    type StringBuffer_Ptr is access all StringBuffer_Obj;

    function new_StringBuffer return StringBuffer_Ptr;

    function new_StringBuffer(
        length : Integer)
      return StringBuffer_Ptr;

    function new_StringBuffer(
        str : String_Ptr)
      return StringBuffer_Ptr;

    function length(buffer : access StringBuffer_Obj) return Integer;

    function capacity(buffer : access StringBuffer_Obj) return Integer;

    procedure ensureCapacity(buffer : access StringBuffer_Obj;
        minimumCapacity : Integer);

    procedure setLength(buffer : access StringBuffer_Obj;
        newLength : Integer);

    function charAt(buffer : access StringBuffer_Obj;
        index : Integer)
      return Wide_Character;

    procedure getChars(buffer : access StringBuffer_Obj;
        srcBegin : Integer;
        srcEnd : Integer;
        dst : Wide_String;
        dstBegin : Integer);

    procedure setCharAt(buffer : access StringBuffer_Obj;
        index : Integer;
        ch : Wide_Character);

    function append(buffer : access StringBuffer_Obj;
        obj : Object_Ptr)
      return StringBuffer_Ptr;

    function append(buffer : access StringBuffer_Obj;
        str : String_Ptr)
      return StringBuffer_Ptr;

    function append(buffer : access StringBuffer_Obj;
        str : Wide_String)
      return StringBuffer_Ptr;

    function append(buffer : access StringBuffer_Obj;
        str : Wide_String;
        offset : Integer;
        len : Integer)
      return StringBuffer_Ptr;

    function append(buffer : access StringBuffer_Obj;
        b : Boolean)
      return StringBuffer_Ptr;

    function append(buffer : access StringBuffer_Obj;
        c : Wide_Character)
      return StringBuffer_Ptr;

    function append(buffer : access StringBuffer_Obj;
        i : Integer)
      return StringBuffer_Ptr;

    function append(buffer : access StringBuffer_Obj;
        l : Long_Integer)
      return StringBuffer_Ptr;

    function append(buffer : access StringBuffer_Obj;
        f : Float)
      return StringBuffer_Ptr;

    function append(buffer : access StringBuffer_Obj;
        d : Long_Float)
      return StringBuffer_Ptr;

    function insert(buffer : access StringBuffer_Obj;
        offset : Integer;
        obj : Object_Ptr)
      return StringBuffer_Ptr;

    function insert(buffer : access StringBuffer_Obj;
        offset : Integer;
        str : String_Ptr)
      return StringBuffer_Ptr;

    function insert(buffer : access StringBuffer_Obj;
        offset : Integer;
        str : Wide_String)
      return StringBuffer_Ptr;

    function insert(buffer : access StringBuffer_Obj;
        offset : Integer;
        b : Boolean)
      return StringBuffer_Ptr;

    function insert(buffer : access StringBuffer_Obj;
        offset : Integer;
        c : Wide_Character)
      return StringBuffer_Ptr;

    function insert(buffer : access StringBuffer_Obj;
        offset : Integer;
        i : Integer)
      return StringBuffer_Ptr;

    function insert(buffer : access StringBuffer_Obj;
        offset : Integer;
        l : Long_Integer)
      return StringBuffer_Ptr;

    function insert(buffer : access StringBuffer_Obj;
        offset : Integer;
        f : Float)
      return StringBuffer_Ptr;

    function insert(buffer : access StringBuffer_Obj;
        offset : Integer;
        d : Long_Float)
      return StringBuffer_Ptr;

    function toString(buffer : access StringBuffer_Obj) return String_Ptr;

    pragma Import(Java, charAt);
    pragma Import(Java, length);
    pragma Import(Java, append);
    pragma Import(Java, capacity);
    pragma Import(Java, ensureCapacity);
    pragma Import(Java, setCharAt);
    pragma Import(Java, setLength);
    pragma Import(Java, toString);
    pragma Import(Java, insert);
    pragma Import(Java, getChars);

    pragma Import(Java_Constructor, new_StringBuffer);

    -- The following constructor comes from java.lang.String:

    function new_String(
        buffer : StringBuffer_Ptr)
      return String_Ptr;
    pragma Import(Java_Constructor, new_String, "java/lang/String.<init>");

end java.lang.StringBuffer;
