-- $Source: /home/dsd/d/aa/monoBANK/AA/java_lang_String.ada,v $ 
-- $Revision: 1.2 $ $Date: 96/11/11 13:51:16 $ $Author: stt $ 
-- with java.lang.StringBuffer; use java.lang.StringBuffer; -- circular
with java.lang; use java.lang;
package java.lang.String is
    pragma Preelaborate(java.lang.String);

    type String_Obj is new Object with null record;
    type String_Ptr is access all String_Obj;

    type String_Array is array(Positive range <>) of String_Ptr;
    pragma Convention(Java, String_Array);  -- No dope when passed
      -- Used for arguments to stand-alone app, among other things

    function new_String return String_Ptr;

    function new_String(
        value : String_Ptr)
      return String_Ptr;

    function new_String(
        value : Wide_String)
      return String_Ptr;

    function new_String(
        value : Wide_String;
        offset : Integer;
        count : Integer)
      return String_Ptr;

    subtype String is Standard.String;  -- overcome hiding

    function new_String(
        ascii : String;
        hibyte : Integer;
        offset : Integer;
        count : Integer)
      return String_Ptr;

    function new_String(
        ascii : String;
        hibyte : Integer)
      return String_Ptr;

    -- The following constructor was moved to java.lang.StringBuffer:

    -- function new_String(
    --     buffer : StringBuffer_Ptr)
    --   return String_Ptr;

    function length(Obj : access String_Obj) return Integer;

    function charAt(Obj : access String_Obj;
        index : Integer)
      return Wide_Character;

    procedure getChars(Obj : access String_Obj;
        srcBegin : Integer;
        srcEnd : Integer;
        dst : Wide_String;
        dstBegin : Integer);

    procedure getBytes(Obj : access String_Obj;
        srcBegin : Integer;
        srcEnd : Integer;
        dst : String;
        dstBegin : Integer);

    function "="(Left : String_Obj; Right : Object'Class) return Boolean;

    function equalsIgnoreCase(Obj : access String_Obj;
        anotherString : String_Ptr)
      return Boolean;

    function compareTo(Obj : access String_Obj;
        anotherString : String_Ptr)
      return Integer;

    function regionMatches(Obj : access String_Obj;
        toffset : Integer;
        other : String_Ptr;
        ooffset : Integer;
        len : Integer)
      return Boolean;

    function regionMatches(Obj : access String_Obj;
        ignoreCase : Boolean;
        toffset : Integer;
        other : String_Ptr;
        ooffset : Integer;
        len : Integer)
      return Boolean;

    function startsWith(Obj : access String_Obj;
        prefix : String_Ptr;
        toffset : Integer)
      return Boolean;

    function startsWith(Obj : access String_Obj;
        prefix : String_Ptr)
      return Boolean;

    function endsWith(Obj : access String_Obj;
        suffix : String_Ptr)
      return Boolean;

    function hashCode(Obj : access String_Obj) return Integer;

    function indexOf(Obj : access String_Obj;
        ch : Integer)
      return Integer;

    function indexOf(Obj : access String_Obj;
        ch : Integer;
        fromIndex : Integer)
      return Integer;

    function lastIndexOf(Obj : access String_Obj;
        ch : Integer)
      return Integer;

    function lastIndexOf(Obj : access String_Obj;
        ch : Integer;
        fromIndex : Integer)
      return Integer;

    function indexOf(Obj : access String_Obj;
        str : String_Ptr)
      return Integer;

    function indexOf(Obj : access String_Obj;
        str : String_Ptr;
        fromIndex : Integer)
      return Integer;

    function lastIndexOf(Obj : access String_Obj;
        str : String_Ptr)
      return Integer;

    function lastIndexOf(Obj : access String_Obj;
        str : String_Ptr;
        fromIndex : Integer)
      return Integer;

    function substring(Obj : access String_Obj;
        beginIndex : Integer)
      return String_Ptr;

    function substring(Obj : access String_Obj;
        beginIndex : Integer;
        endIndex : Integer)
      return String_Ptr;

    function concat(Obj : access String_Obj;
        str : String_Ptr)
      return String_Ptr;

    function replace(Obj : access String_Obj;
        oldChar : Wide_Character;
        newChar : Wide_Character)
      return String_Ptr;

    function toLowerCase(Obj : access String_Obj) return String_Ptr;

    function toUpperCase(Obj : access String_Obj) return String_Ptr;

    function trim(Obj : access String_Obj) return String_Ptr;

    function toString(Obj : access String_Obj) return String_Ptr;

    function toCharArray(Obj : access String_Obj) return Wide_String;

    function valueOf(
        obj : Object_Ptr)
      return String_Ptr;

    function valueOf(
        data : Wide_String)
      return String_Ptr;

    function valueOf(
        data : Wide_String;
        offset : Integer;
        count : Integer)
      return String_Ptr;

    function copyValueOf(
        data : Wide_String;
        offset : Integer;
        count : Integer)
      return String_Ptr;

    function copyValueOf(
        data : Wide_String)
      return String_Ptr;

    function valueOf(
        b : Boolean)
      return String_Ptr;

    function valueOf(
        c : Wide_Character)
      return String_Ptr;

    function valueOf(
        i : Integer)
      return String_Ptr;

    function valueOf(
        l : Long_Integer)
      return String_Ptr;

    function valueOf(
        f : Float)
      return String_Ptr;

    function valueOf(
        d : Long_Float)
      return String_Ptr;

    function intern(Obj : access String_Obj) return String_Ptr;

    pragma Import(Java, "=", "equals");
    pragma Import(Java, replace);
    pragma Import(Java, intern);
    pragma Import(Java, indexOf);
    pragma Import(Java, charAt);
    pragma Import(Java, compareTo);
    pragma Import(Java, length);
    pragma Import(Java, toLowerCase);
    pragma Import(Java, valueOf);
    pragma Import(Java, toCharArray);
    pragma Import(Java, concat);
    pragma Import(Java, copyValueOf);
    pragma Import(Java, hashCode);
    pragma Import(Java, toUpperCase);
    pragma Import(Java, trim);
    pragma Import(Java, startsWith);
    pragma Import(Java, lastIndexOf);
    pragma Import(Java, regionMatches);
    pragma Import(Java, substring);
    pragma Import(Java, getBytes);
    pragma Import(Java, endsWith);
    pragma Import(Java, equalsIgnoreCase);
    pragma Import(Java, toString);
    pragma Import(Java, getChars);

    pragma Import(Java_Constructor, new_String);

end java.lang.String;
