-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.unsigned.bdy,v $ 
-- $Revision: 1.6 $ $Date: 96/06/27 12:10:11 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

with Interfaces;
with Ada.Unchecked_Conversion;

package body System.RTS.Unsigned is

    pragma Suppress( Elaboration_Check );

    function conv is new Ada.Unchecked_Conversion(
				      Interfaces.Unsigned_32,
				      Unsigned_Integer);

    function conv is new Ada.Unchecked_Conversion(
				      Unsigned_Integer,
				      Interfaces.Unsigned_32);

-- The following operators perform 32-bit wide logical shifts.
-- Only the 5 least significant bits of Count are used.
-- "Negative" counts do not reverse the shift direction.
-- Bodies are implemented in terms of Interfaces.Shift_Left and Shift_Right

    function shl( Value, Count: Unsigned_Integer ) return Unsigned_Integer is
    begin
        return conv(Interfaces.Shift_Left(conv(Value), Natural(Count)));
    end;

    function shr( Value, Count: Unsigned_Integer ) return Unsigned_Integer is
    begin
        return conv(Interfaces.Shift_Right(conv(Value), Natural(Count)));
    end;

end System.RTS.Unsigned;
