-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.integer_image_and_value_pkg.spc,v $
-- $Revision: 1.4 $ $Date: 96/04/29 11:34:46 $ $Author: akira $
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.RTS.Unsigned;

package System.RTS.Integer_Image_And_Value_Pkg is

    pragma Suppress( Elaboration_Check );

    function RTS_Integer_Image (
      The_Integer : Integer
    ) return String;
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Returns the image attribute ('IMAGE) of an integer type.
    --+-------------------------------------------------------
    pragma export (Ada,
                   RTS_Integer_Image,
                   External_Name => "rts_integer_image");
    pragma global (RTS_Integer_Image);

    function RTS_Integer_Wide_Image (
      The_Integer : Integer
    ) return Wide_String;
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Returns the image attribute ('WIDE_IMAGE) of an integer type.
    --+-------------------------------------------------------
    pragma export (Ada,
                   RTS_Integer_Wide_Image,
                   External_Name => "rts_integer_wide_image");
    pragma global (RTS_Integer_Wide_Image);

    function RTS_Integer_Value (
      The_Image : String
    ) return Integer;
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Given a string representing an integer, returns the value of
    --| the corresponding integer type ('VALUE). Raises
    --| CONSTRAINT_ERROR if the string is not a syntactically legal
    --| integer literal.
    --+-------------------------------------------------------
    pragma export (Ada,
                   RTS_Integer_Value,
                   External_Name => "rts_integer_value");
    pragma global (RTS_Integer_Value);

    function RTS_Integer_Wide_Value (
      The_Image : Wide_String
    ) return Integer;
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Given a string representing an integer, returns the value of
    --| the corresponding integer type ('WIDE_VALUE). Raises
    --| CONSTRAINT_ERROR if the string is not a syntactically legal
    --| integer literal.
    --+-------------------------------------------------------
    pragma export (Ada,
                   RTS_Integer_Wide_Value,
                   External_Name => "rts_integer_wide_value");
    pragma global (RTS_Integer_Wide_Value);

    function RTS_Unsigned_Image (
      The_Unsigned : System.RTS.Unsigned.Unsigned_Integer
    ) return String;
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Returns the image attribute ('IMAGE) of an unsigned integer type.
    --+-------------------------------------------------------
    pragma export (Ada,
                   RTS_Unsigned_Image,
                   External_Name => "rts_unsigned_image");
    pragma global (RTS_Unsigned_Image);

    function RTS_Unsigned_Wide_Image (
      The_Unsigned : System.RTS.Unsigned.Unsigned_Integer
    ) return Wide_String;
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Returns the image attribute ('WIDE_IMAGE) of an unsigned type.
    --+-------------------------------------------------------
    pragma export (Ada,
                   RTS_Unsigned_Wide_Image,
                   External_Name => "rts_unsigned_wide_image");
    pragma global (RTS_Unsigned_Wide_Image);

    function RTS_Unsigned_Value (
      The_Image : String
    ) return System.RTS.Unsigned.Unsigned_Integer;
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Given a string representing an unsigned_integer, returns the value of
    --| the corresponding unsigned type ('VALUE). Raises
    --| CONSTRAINT_ERROR if the string is not a syntactically legal
    --| unsigned integer literal.
    --+-------------------------------------------------------
    pragma export (Ada,
                   RTS_Unsigned_Value,
                   External_Name => "rts_unsigned_value");
    pragma global (RTS_Unsigned_Value);

    function RTS_Unsigned_Wide_Value (
      The_Image : Wide_String
    ) return System.RTS.Unsigned.Unsigned_Integer;
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Given a string representing an unsigned_integer, returns the value of
    --| the corresponding unsigned type ('WIDE_VALUE). Raises
    --| CONSTRAINT_ERROR if the string is not a syntactically legal
    --| unsigned_integer literal.
    --+-------------------------------------------------------
    pragma export (Ada,
                   RTS_Unsigned_Wide_Value,
                   External_Name => "rts_unsigned_wide_value");
    pragma global (RTS_Unsigned_Wide_Value);

    function RTS_Integer_Width (
      First_Position : Integer;
      Last_Position  : Integer
    )
    return Integer;
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Return maximum length of the image of the integers
    --| between First_Position and Last_Position.
    --| Only called if width is not statically known.
    --+-------------------------------------------------------
    pragma export (Ada,
                   RTS_Integer_Width,
                   External_Name => "rts_integer_width");
    pragma global (RTS_Integer_Width);

    function RTS_Unsigned_Width (
      Position  : System.RTS.Unsigned.Unsigned_Integer
    )
    return Integer;
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Return maximum length of the image of the unsigned_integers.
    --| Only called if width is not statically known.
    --+-------------------------------------------------------
    pragma export (Ada,
                   RTS_Unsigned_Width,
                   External_Name => "rts_unsigned_width");
    pragma global (RTS_Unsigned_Width);

end System.RTS.Integer_Image_And_Value_Pkg;
