-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.string_utilities.bdy,v $
-- $Revision: 1.2 $ $Date: 95/10/10 13:46:18 $ $Author: akira $
--        Copyright (C) 1995 by Intermetrics, Inc.   

package body System.RTS.String_Utilities is

    pragma Suppress( Elaboration_Check );

    subtype Lower_Case_Range is character range 'a' .. 'z';
    subtype Upper_Case_Range is character range 'A' .. 'Z';

    Upper_Case_Array : constant array (Lower_Case_Range) of
      character := (
        'a' => 'A', 'b' => 'B', 'c' => 'C', 'd' => 'D', 'e' => 'E',
        'f' => 'F', 'g' => 'G', 'h' => 'H', 'i' => 'I', 'j' => 'J',
        'k' => 'K', 'l' => 'L', 'm' => 'M', 'n' => 'N', 'o' => 'O',
        'p' => 'P', 'q' => 'Q', 'r' => 'R', 's' => 'S', 't' => 'T',
        'u' => 'U', 'v' => 'V', 'w' => 'W', 'x' => 'X', 'y' => 'Y',
        'z' => 'Z'
      );

    Lower_Case_Array : constant array (Upper_Case_Range) of
      character := (
        'A' => 'a', 'B' => 'b', 'C' => 'c', 'D' => 'd', 'E' => 'e',
        'F' => 'f', 'G' => 'g', 'H' => 'h', 'I' => 'i', 'J' => 'j',
        'K' => 'k', 'L' => 'l', 'M' => 'm', 'N' => 'n', 'O' => 'o',
        'P' => 'p', 'Q' => 'q', 'R' => 'r', 'S' => 's', 'T' => 't',
        'U' => 'u', 'V' => 'v', 'W' => 'w', 'X' => 'x', 'Y' => 'y',
        'Z' => 'z'
      );

    function Upper_Case (C : in character) return character is
    begin
        if C in Lower_Case_Range then
            -- Needs conversion - lower case alphabetic
            return Upper_Case_Array(C);
        else
            -- Already upper-case or non-alphabetic
            return C;
        end if;
    end Upper_Case;

    function Lower_Case (C : in character) return character is
    begin
        if C in Upper_Case_Range then
            -- Needs conversion - upper-case alphabetic
            return Lower_Case_Array(C);
        else
            -- Already lower-case or non-alphabetic
            return C;
        end if;
    end Lower_Case;

    function Upper_Case (S : in string) return string is
        Result : string (S'FIRST .. S'LAST);
    begin
        for I in S'RANGE loop
            Result(I) := Upper_Case(S(I));
        end loop;
        return Result;
    end Upper_Case;

    function Lower_Case (S : in string) return string is
        Result : string (S'FIRST .. S'LAST);
    begin
        for I in S'RANGE loop
            Result(I) := Lower_Case(S(I));
        end loop;
        return Result;
    end Lower_Case;

end System.RTS.String_Utilities;
