-- $Source: /home/dsd/d/aa/monoBANK/AA/system_java.spc,v $
-- $Revision: 1.5 $ $Date: 96/11/11 13:20:47 $ $Author: stt $
--        Copyright (C) 1995 by Intermetrics, Inc.   

with java.lang;
package System is

    pragma Suppress( Elaboration_Check );
    pragma Preelaborate(System);

    type Name is (Jcode);
    System_Name  : constant Name := Jcode;

    -- System-Dependent Named Numbers:

    Min_Int               : constant :=-2**63;
    Max_Int               : constant := 2**63 - 1;

    Max_Binary_Modulus    : constant := 2**64;
    Max_Nonbinary_Modulus : constant := 2**63 - 1;

    Max_Base_Digits       : constant := 15;
    Max_Digits            : constant := 15;

    Max_Mantissa          : constant := 63;
    Fine_Delta            : constant := 2.0 ** (-63);

    Tick                  : constant := 0.015_625; -- TBD

    -- Storage-related Declarations:

    type Address	  is private;
    Null_Address          : constant Address;

    Storage_Unit          : constant := 8;
    Word_Size             : constant := 4 * Storage_Unit;
    Memory_Size           : constant := 2**32;

    -- Address Comparison:

    function "<"( Left : Address; Right  : Address ) return Boolean;
    function ">"( Left : Address; Right  : Address ) return Boolean;
    function "<="( Left : Address; Right : Address ) return Boolean;
    function ">="( Left : Address; Right : Address ) return Boolean;

    -- Other System-Dependent Declarations:

    type Bit_Order is ( High_Order_First, Low_Order_First );
    Default_Bit_Order : constant Bit_Order := Low_Order_First;

    -- Priority-related Declarations( see D.1 ):

    subtype ANY_PRIORITY is INTEGER range 1 .. 10;
    subtype PRIORITY is ANY_PRIORITY range
      ANY_PRIORITY'FIRST ..  ANY_PRIORITY'LAST;
    subtype INTERRUPT_PRIORITY is ANY_PRIORITY
      range PRIORITY'LAST + 1 .. ANY_PRIORITY'LAST;

    Default_Priority : constant PRIORITY := (PRIORITY'FIRST + PRIORITY'LAST)/2;

private

    type Address is new java.lang.Object_Ptr;
    Null_Address : constant Address := null;

    pragma Import( Intrinsic, "<",  "*e_system.<" );
    pragma Import( Intrinsic, "<=", "*e_system.<=" );
    pragma Import( Intrinsic, ">",  "*e_system.>" );
    pragma Import( Intrinsic, ">=", "*e_system.>=" );

end System;
