-- $Source: /home/dsd/d/aa/monoBANK/AA/system.storage_pools.spc,v $
-- $Revision: 1.2 $ $Date: 95/10/10 13:38:03 $ $Author: akira $
--        Copyright (C) 1995 by Intermetrics, Inc.   

with Ada.Finalization;
with System.Storage_Elements;

package System.Storage_Pools is
    pragma Suppress( Elaboration_Check );

    pragma Preelaborate(System.Storage_Pools);

    type Root_Storage_Pool is abstract new
          Ada.Finalization.Limited_Controlled with private;

    procedure Allocate(
      Pool                     : in out Root_Storage_Pool;
      Storage_Address          : out Address;
      Size_In_Storage_Elements : in Storage_Elements.Storage_Count;
      Alignment                : in Storage_Elements.Storage_Count) is abstract;


    procedure Deallocate(
      Pool                     : in out Root_Storage_Pool;
      Storage_Address          : in Address;
      Size_In_Storage_Elements : in Storage_Elements.Storage_Count;
      Alignment                : in Storage_Elements.Storage_Count) is abstract;


    function Storage_Size(Pool : Root_Storage_Pool)
        return Storage_Elements.Storage_Count is abstract;

private

    type Root_Storage_Pool is
      abstract new Ada.Finalization.Limited_Controlled with null record;
end System.Storage_Pools;
