-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.float_image_and_value_pkg.bdy,v $ 
-- $Revision: 1.3 $ $Date: 95/11/20 14:14:31 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.RTS.Float_IO_Support;
with Ada.Characters.Handling;

package body System.RTS.Float_Image_And_Value_Pkg is

    pragma Suppress( Elaboration_Check );

    package FIO renames System.RTS.Float_IO_Support;

    function RTS_Float_Image ( The_Float  : TGT.Longest_Float;
      	    	    	       Num_Digits : Integer ) return String is
    begin
	return FIO.Float_Image( ITEM => The_Float,
	    	    	    	FORE => 2,
				AFT  => Num_Digits-1,
				EXP  => 3);
    end RTS_Float_Image;
    

    function RTS_Float_Wide_Image ( The_Float  : TGT.Longest_Float;
      	    	    	    	    Num_Digits : Integer ) return Wide_String is
    begin
	return Ada.Characters.Handling.To_Wide_String(
				    FIO.Float_Image( ITEM => The_Float,
				    FORE => 2,
				    AFT  => Num_Digits-1,
				    EXP  => 3));
    end RTS_Float_Wide_Image;				    

    function RTS_Float_Value ( The_Image : String ) return TGT.Longest_Float is
    begin
   	return FIO.Float_Value( The_Image );
    end RTS_Float_Value;

    function RTS_Float_Wide_Value ( The_Image : Wide_String ) 
       return TGT.Longest_Float is
    begin
   	return FIO.Float_Value( Ada.Characters.Handling.To_String( The_Image ));
    end RTS_Float_Wide_Value;


    function RTS_Float_Width ( First_Position : TGT.Longest_Float;
      	    	    	       Last_Position  : TGT.Longest_Float;
      	    	    	       Num_Digits     : Integer ) return Integer is
        use type TGT.Longest_Float;
    begin
    	if First_Position > Last_Position then
	    return 0;
	end if;
	
    	return Num_Digits+5;
    end RTS_Float_Width;		    			       


end System.RTS.Float_Image_And_Value_Pkg;
