-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.float_image_and_value_pkg.spc,v $
-- $Revision: 1.5 $ $Date: 96/06/21 13:19:49 $ $Author: akira $
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.RTS.TGT;

package System.RTS.Float_Image_And_Value_Pkg is

    pragma Suppress( Elaboration_Check );

    package TGT renames System.RTS.TGT;

    function RTS_Float_Image ( The_Float  : TGT.Longest_Float;
      	    	    	       Num_Digits : Integer ) return String;
    pragma export (Ada,
                   RTS_Float_Image,
                   External_Name => "rts_float_image");
    pragma global (RTS_Float_Image);

    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Returns the image attribute ('IMAGE) of a float type.
    --| Digits designates how many digits should be in the output.
    --+-------------------------------------------------------

    function RTS_Float_Wide_Image( The_Float  : TGT.Longest_Float;
      	    	    	    	   Num_Digits : Integer ) return Wide_String;
    pragma export (Ada,
                   RTS_Float_Wide_Image,
                   External_Name => "rts_float_wide_image");
    pragma global (RTS_Float_Wide_Image);

    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Returns the image attribute ('WIDE_IMAGE) of a float type.
    --| Digits designates how many digits should be in the output.
    --+-------------------------------------------------------

    function RTS_Float_Value ( The_Image : String ) return TGT.Longest_Float;
    pragma export (Ada,
                   RTS_Float_Value,
                   External_Name => "rts_float_value");
    pragma global (RTS_Float_Value);

    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Given a string representing a float, returns the value of
    --| the corresponding float type ('VALUE). Raises
    --| CONSTRAINT_ERROR if the string is not a syntactically legal
    --| float literal.
    --+-------------------------------------------------------

    function RTS_Float_Wide_Value ( The_Image : Wide_String ) 
	return TGT.Longest_Float;
    pragma export (Ada,
                   RTS_Float_Wide_Value,
                   External_Name => "rts_float_wide_value");
    pragma global (RTS_Float_Wide_Value);

    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Given a string representing a float, returns the value of
    --| the corresponding float type ('WIDE_VALUE). Raises
    --| CONSTRAINT_ERROR if the string is not a syntactically legal
    --| float literal.
    --+-------------------------------------------------------

    function RTS_Float_Width ( First_Position : TGT.Longest_Float;
      	    	    	       Last_Position  : TGT.Longest_Float;
      	    	    	       Num_Digits     : Integer ) return Integer;
    pragma export (Ada,
                   RTS_Float_Width,
                   External_Name => "rts_float_width");
    pragma global (RTS_Float_Width);

    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Return maximum length of the image of the a number in
    --| the float type. Only called if width is not statically
    --| known.
    --+-------------------------------------------------------

end System.RTS.Float_Image_And_Value_Pkg;
