
package System.RTS.TGT.DLLInit is

   -- This package contains code to handle
   -- DLL thread attach and detach messages.

   pragma Suppress( Elaboration_Check );

   procedure Initialize;
   pragma Export (C, Initialize, "rts_dll_initialize");
   -- Initializes data structures used later by Thread_Attach.
   -- Must be called in a completely initialized Ada context.


   function Thread_Attach return Boolean;
   pragma Export (C, Thread_Attach, "rts_dll_thread_attach");
   -- When Thread_Attach is called, a TCB has already been
   -- allocated and initialized. This routine allocates and
   -- initializes the ITCB, secondary stack, etc. for this
   -- thread. Returns True if successful, otherwise False.


   function Thread_Detach return Boolean;
   pragma Export (C, Thread_Detach, "rts_dll_thread_detach");
   -- Clean up, deallocate any storage allocated by Thread_Attach.

end System.RTS.TGT.DLLInit;
