-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.integer_io_support.spc,v $ 
-- $Revision: 1.2 $ $Date: 95/10/10 13:32:59 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

package System.RTS.Integer_IO_Support is

    pragma Suppress( Elaboration_Check );

    function INTEGER_IMAGE (
                         ITEM : INTEGER;
                         WIDTH : INTEGER;
                         BASE  : INTEGER)  return STRING;


--| Effect
--|   Returns a string with the IMAGE of ITEM.  If BASED /= 10, then
--| it has the syntax of a based number, with 1 or 2 digits for the
--| base.  There is a '-' sign if ITEM is negative, otherwise no
--| character position is reserved for a positive number.
--|   If the so-defined number consumes fewer than WIDTH positions, then
--| it is padded with leading spaces.  If WIDTH is too small, then WIDTH
--| is ignored.
--|
--| Algorithm
--|   Accumulate the result string BACKWARDS.  X holds the NEGATIVE magnitude
--| value remaining to be output. (Negative is used because it can handle
--| integer'first, which cannot be done using positive values for twos
--| complement machines.)
--|
--| Requires
--|   BASE is in range 2 .. 16.  Since this routine is a "helping" routine,
--|   PUT(file) and PUT(string) have already checked that base is correct.

    int_to_char : constant string (1 .. 16) := "0123456789ABCDEF";
    -- int_to_char(i+1) is the hex_char for i
    -- used in INTEGER_IMAGE



end System.RTS.Integer_IO_Support;
