-- $Source: /home/dsd/d/aa/monoBANK/AA/interfaces_x86.spc,v $ 
-- $Revision: 1.5 $ $Date: 95/11/13 14:36:43 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

-- ARM 5.0;B.2

package Interfaces is

    pragma Pure(Interfaces);
    pragma Suppress( Elaboration_Check );

    type Unsigned_Integer is mod 2**32;

    type Integer_32 is range -2**31 .. 2**31-1;  --2's complement
    type Integer_16 is range -2**15 .. 2**15-1;  --2's complement
    type Integer_8  is range -2**7  .. 2**7 -1;  --2's complement

    type Unsigned_32 is mod 2**32;
    type Unsigned_16 is mod 2**16;
    type Unsigned_8  is mod 2**8; 

    type IEEE_Float_32 is new FLOAT;
    type IEEE_Float_64 is new LONG_FLOAT;

    function Shift_Left_8( Value : Unsigned_8; Amount : Natural ) return Unsigned_8;
    function Shift_Right_8( Value : Unsigned_8; Amount : Natural ) return Unsigned_8;
    function Shift_Right_Arithmetic_8( Value : Unsigned_8; Amount : Natural ) return Unsigned_8;
    function Rotate_Left_8( Value : Unsigned_8; Amount : Natural ) return Unsigned_8;
    function Rotate_Right_8( Value : Unsigned_8; Amount : Natural ) return Unsigned_8;

    pragma Import (Intrinsic, Shift_Left_8, Link_Name => "C_SHL_8" );
    pragma Import (Intrinsic, Shift_Right_8, Link_Name => "C_SHR_8" );
    pragma Import (Intrinsic, Shift_Right_Arithmetic_8, Link_Name =>"C_SAR_8" );
    pragma Import (Intrinsic, Rotate_Left_8, Link_Name => "C_ROL_8" );
    pragma Import (Intrinsic, Rotate_Right_8, Link_Name => "C_ROR_8" );

    function Shift_Left( Value : Unsigned_8; Amount : Natural ) return Unsigned_8 renames Shift_Left_8;
    function Shift_Right( Value : Unsigned_8; Amount : Natural ) return Unsigned_8 renames Shift_Right_8;
    function Shift_Right_Arithmetic( Value : Unsigned_8; Amount : Natural ) return Unsigned_8 renames Shift_Right_Arithmetic_8;
    function Rotate_Left( Value : Unsigned_8; Amount : Natural ) return Unsigned_8 renames Rotate_Left_8;
    function Rotate_Right( Value : Unsigned_8; Amount : Natural ) return Unsigned_8 renames Rotate_Right_8;

    function Shift_Left_16( Value : Unsigned_16; Amount : Natural ) return Unsigned_16;
    function Shift_Right_16( Value : Unsigned_16; Amount : Natural ) return Unsigned_16;
    function Shift_Right_Arithmetic_16( Value : Unsigned_16; Amount : Natural ) return Unsigned_16;
    function Rotate_Left_16( Value : Unsigned_16; Amount : Natural ) return Unsigned_16;
    function Rotate_Right_16( Value : Unsigned_16; Amount : Natural ) return Unsigned_16;

    pragma Import (Intrinsic, Shift_Left_16, Link_Name => "C_SHL_16" );
    pragma Import (Intrinsic, Shift_Right_16, Link_Name => "C_SHR_16" );
    pragma Import (Intrinsic, Shift_Right_Arithmetic_16, Link_Name =>"C_SAR_16" );
    pragma Import (Intrinsic, Rotate_Left_16, Link_Name => "C_ROL_16" );
    pragma Import (Intrinsic, Rotate_Right_16, Link_Name => "C_ROR_16" );

    function Shift_Left( Value : Unsigned_16; Amount : Natural ) return Unsigned_16 renames Shift_Left_16;
    function Shift_Right( Value : Unsigned_16; Amount : Natural ) return Unsigned_16 renames Shift_Right_16;
    function Shift_Right_Arithmetic( Value : Unsigned_16; Amount : Natural ) return Unsigned_16 renames Shift_Right_Arithmetic_16;
    function Rotate_Left( Value : Unsigned_16; Amount : Natural ) return Unsigned_16 renames Rotate_Left_16;
    function Rotate_Right( Value : Unsigned_16; Amount : Natural ) return Unsigned_16 renames Rotate_Right_16;

    function Shift_Left_32( Value : Unsigned_32; Amount : Natural ) return Unsigned_32;
    function Shift_Right_32( Value : Unsigned_32; Amount : Natural ) return Unsigned_32;
    function Shift_Right_Arithmetic_32( Value : Unsigned_32; Amount : Natural ) return Unsigned_32;
    function Rotate_Left_32( Value : Unsigned_32; Amount : Natural ) return Unsigned_32;
    function Rotate_Right_32( Value : Unsigned_32; Amount : Natural ) return Unsigned_32;

    pragma Import (Intrinsic, Shift_Left_32, Link_Name => "C_SHL_32" );
    pragma Import (Intrinsic, Shift_Right_32, Link_Name => "C_SHR_32" );
    pragma Import (Intrinsic, Shift_Right_Arithmetic_32, Link_Name =>"C_SAR_32" );
    pragma Import (Intrinsic, Rotate_Left_32, Link_Name => "C_ROL_32" );
    pragma Import (Intrinsic, Rotate_Right_32, Link_Name => "C_ROR_32" );

    function Shift_Left( Value : Unsigned_32; Amount : Natural ) return Unsigned_32 renames Shift_Left_32;
    function Shift_Right( Value : Unsigned_32; Amount : Natural ) return Unsigned_32 renames Shift_Right_32;
    function Shift_Right_Arithmetic( Value : Unsigned_32; Amount : Natural ) return Unsigned_32 renames Shift_Right_Arithmetic_32;
    function Rotate_Left( Value : Unsigned_32; Amount : Natural ) return Unsigned_32 renames Rotate_Left_32;
    function Rotate_Right( Value : Unsigned_32; Amount : Natural ) return Unsigned_32 renames Rotate_Right_32;

end Interfaces;
