-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.sized_heap_pkg.spc,v $ 
-- $Revision: 1.1 $ $Date: 1996/11/27 21:43:39 $ $Author: stt $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.Storage_Elements;

package System.RTS.Sized_Heap_Pkg is
    -- This package implements a "sized heap", also called a "collection"

    pragma Suppress( Elaboration_Check );

    package SSE renames System.Storage_Elements;


    procedure RTS_Sized_Heap_Initialize (
       Sized_Heap   : in Address; -- Object of size Storage_Size
       Storage_Size : in SSE.Storage_Count
    );  
    pragma Export (ada,
		   RTS_Sized_Heap_Initialize,
                   "rts_sized_heap_initialize" );

    --* OVERVIEW
    -- THis routine should be called before attempting to allocate from
    -- a sized_heap.  A portion of the size specified will be used for
    -- implementation overhead
    
    function RTS_Allocate_From_Sized_Heap (
       Sized_Heap               : in Address;
       Size_In_Storage_Elements : in SSE.Storage_Count
    ) return Address;
    pragma Export (ada,
		   RTS_Allocate_From_Sized_Heap,
                   "rts_allocate_from_sized_heap" );

    
    procedure RTS_Deallocate_From_Sized_Heap (
       Sized_Heap      : in Address;
       Storage_Address : in Address
    );
    pragma Export (ada,
		   RTS_Deallocate_From_Sized_Heap,
                   "rts_deallocate_from_sized_heap" );

end System.RTS.Sized_Heap_Pkg;
