with SYSTEM;
with System.Rts.Types;
with System.RTS.Tgt_INTEGERS;
use System.Rts.Types;
with System.Rts.TCB_TDEP;

package SYSTEM.RTS.TCB is
 
   subtype TCB_RECORD is SYSTEM.RTS.TCB_TDEP.TCB_RECORD;
     
   type REF_TCB is access all TCB_RECORD;
   
   function CURR_TCB return REF_TCB;
   
   function ENVIRONMENT_TCB return REF_TCB;
   function ENVIRONMENT_TCB return DATA_ADDRESS;

   -- Allocate TCB from the heap and return a reference to it.  Must be called
   -- by the thread creating this TCB. Copy the display of the current task to
   -- the display in this TCB.
   function ALLOCATE_TCB return REF_TCB;

   -- Initialize a TCB.  Must be called by the thread which own this TCB. Sets
   -- up all TCB fields. Initializes FS segment pointers, TCB pointer at bottom
   -- of stack, sets exception handler hooks, etc.
   -- Note that calls to CURR_TCB are not valid until INITIALIZE_TCB is called.
   procedure INITIALIZE_TCB (TCB                : in REF_TCB;
                             THREAD_POINTER     : in SYSTEM.ADDRESS;
                             SAVED_INTEGER_DATA : in SYSTEM.ADDRESS);

   procedure Restore_Object (SAVED_INTEGER_DATA	: in SYSTEM.ADDRESS;
   			     IS_ENVTCB		: in INTEGER );


   pragma Import (ada, environment_tcb, "_rts_env_tcb");
   pragma Import (Intrinsic, curr_tcb, "*CURR_TCB");
   pragma Import (Ada, Allocate_TCB, "_rts_allocate_tcb");
   pragma Import (Ada, Initialize_TCB, "_rts_initialize_tcb");
   pragma Import (Ada, Restore_Object, "_rts_restore_object");








end SYSTEM.RTS.TCB;
