
with System.Rts.Types;
use System.Rts.Types;
with SYSTEM;

package SYSTEM.RTS.TCB_TDEP is

  EM_STACK_SLOP : constant := 4096;

  type BYTE is mod 2**8;
  type BYTE_STRING is array (NATURAL range <>) of BYTE;
  type ADDRESS_ARRAY is array (NATURAL range <>) of DATA_ADDRESS;

  -- Must match TCB.INC 
  type TCB_RECORD is
     record
        HIGHWATER_MARK     : SYSTEM.ADDRESS;  -- for SS
        LAST_CHUNK         : SYSTEM.ADDRESS;  -- for SS
        THREAD_POINTER     : SYSTEM.ADDRESS;
        TCB_STACK          : DATA_ADDRESS;    -- offset 16#0C#
        TCB_FPT_BAS        : SYSTEM.ADDRESS;
        TCB_FPT_TOS        : SYSTEM.ADDRESS;
        TCB_FPT_LIM        : INTEGER;
        TCB_INITIAL_FP     : DATA_ADDRESS;
        TCB_SAVED_STACK    : DATA_ADDRESS;    -- offset 16#20#
        TCB_IN_EM          : BOOLEAN;         
        EXTRA_B1           : BOOLEAN;         -- for later use
        EXTRA_B2           : BOOLEAN;         -- for later use
        EXTRA_B3           : BOOLEAN;         -- for later use
        EXTRA_A1           : SYSTEM.ADDRESS;  -- for later use
        EXTRA_A2           : SYSTEM.ADDRESS;  -- for later use
        TCB_DISPLAY        : ADDRESS_ARRAY (0..63); -- offset 16#30#
     end RECORD;

end SYSTEM.RTS.TCB_TDEP;
