-- $Source: /home/dsd/d/aa/monoBANK/AA/TSP_system.rts.tgt.kernel.timers.relative.spc,v $ 
-- $Revision: 1.2 $ $Date: 96/10/18 11:52:29 $ $Author: stt $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

-- Derived from:
--  Source: /home/dsd/d/aa/monoBANK/AA/system.rts.tgt.kernel.timers.relative.spc,v   
--  Revision: 1.8    Date: 95/10/27 14:31:49    Author: arra   

with System.RTS.Interface_Types;
package System.RTS.TGT.Kernel.Timers.Relative is

  -- This package implements relative timers,
  -- with Duration as the measure of relative time.

  -- See the abstract versions of the operations for comments, in
  -- System.RTS.TGT.Kernel.Timers.

    type Timer_Record is new Timers.Timer_Record with 
      record
	Amount : Duration := 0.0;
	  -- In some implementations it might make more sense
	  -- to store an absolute time here rather than a duration
        Handle : Interface_Types.Simple_Handle;
          -- Pointer to Win32 handle used for suspend.  Added for NT.
      end record;

    function "<"(Left, Right : Timer_Record) return Boolean;

    procedure Suspend_Until_True_Or_Timeout(
      S : in out Threads.Suspension_Object; 
      Timeout : in out Timer_Record
    );

    procedure Signal_Abort_Upon_Timeout(
      Timeout : in out Timer_Record; 
      Level : Abort_Signals.Abort_Signal_Level);

    procedure Cancel_Timer(
      Timeout : in out Timer_Record);

    function Absolute_Time(
	From_Now : Duration
    ) return Timers.Timer_Record'Class;
    -- This function adds the given From_Now duration to Clock to return
    -- an absolute time.
    -- The time base used is implementation dependent.

end System.RTS.TGT.Kernel.Timers.Relative;
