-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.tgt.kernel.threads.abort_signals.spc,v $ 
-- $Revision: 1.1 $ $Date: 96/02/09 14:16:03 $ $Author: akira $ 
with System.RTS.TGT.Kernel.Abort_Signals;

package System.RTS.TGT.Kernel.Threads.Abort_Signals is

    package ABRT renames System.RTS.TGT.Kernel.Abort_Signals;

    procedure Establish_Abort_Signal_Handler(Handler : ABRT.Abort_Signal_Handler);
	-- This is called once at system startup, to establish
	-- abort handler for all threads.

    procedure Signal_Abort(
      Thread : Threads.Thread_Ptr; Level : Abort_Signal_Level);
	-- Send an abort signal to the specified thread, causing the
	-- Abort_Signal_Handler routine to execute in the context of
	-- the thread.
	-- Both this abort signal and ones generated by
	-- Kernel.Timers.Signal_Abort_Upon_Timeout shall release a
	-- thread from a suspended state (Suspend_Until_True or
	-- Suspend_Until_True_Or_Timeout)

    procedure Defer_Abort_Handling;
	-- While abort handling is deferred, any abort signal is
	-- not delivered until abort handling is undeferred.
	-- If multiple aborts were signalled while deferred,
	-- only the one with the lowest number need be signalled
	-- when undeferred.
	-- Defer_Abort_Handling increments a zero-initialized
	-- counter that is decremented by Undefer_Abort_Handling.
	-- Aborts are automatically deferred while a thread is
	-- holding any mutex(es).

    procedure Undefer_Abort_Handling;
	-- Decrements the abort deferral counter, and if zero,
	-- allows any deferred aborts to occur.

    procedure Reset_Abort;
    	-- Resets the saved state of an abort in progress.

end System.Rts.TGT.Kernel.Threads.Abort_Signals;
