-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.tgt.call_outs_driver.spc,v $
-- $Revision: 1.5 $ $Date: 95/10/10 14:04:43 $ $Author: akira $
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.RTS.Protected_Types_Pkg;
use System.RTS.Protected_Types_Pkg;

package System.RTS.TGT.Call_Outs_Driver is

    pragma Suppress( Elaboration_Check );

--* OVERVIEW
--  The operations in this package are called by the rets of the RTS when
--  a call-out to the genrated code (GC) is used.  The profiles here do not
--  match exactly the interface document, rather they are a bit higher-level,
--  and have two additional parameters, Where and Static_Link, which are
--  not explicitly passed to the GC.  These additional parameters are specified
--  last in the hope that the early parameters don't have to be moved around
--  before doing the actual call-out.  The actual profiles as specified by
--  the document don't actually appear anywhere in the RTS.
--  The body of this package makes calls that conform to those profiles.


     procedure Call_Protected_Subprogram(
	PO           : PO_Access;
	Params       : Param_Block_Ptr;
	Where        : Code_Address;
	Static_Link : Data_Address
     );
     pragma import (Ada,Call_Protected_Subprogram,"rts_call_protected_subprogram");

    -- Large model
    function Call_Evaluate_Barrier(
	PO           : PO_Access;
	Index        : Entry_Member_Index;
	Where        : Code_Address;
	Static_Link : Data_Address
     ) return Boolean;
     pragma import (Ada,Call_Evaluate_Barrier,"rts_call_evaluate_barrier");

    -- Small model.  The generated code is responsible for picking the
    -- right Entry_Member_Index for each barrier expression
    function Call_Evaluate_All_Barriers(
	PO           : PO_Access;
	Where        : Code_Address;
	Static_Link : Data_Address
    ) return Barrier_Vector;
     pragma import (Ada,Call_Evaluate_All_Barriers,"rts_call_evaluate_all_barriers");

    procedure Call_Entry_Body(
	PO           : PO_Access;
	Params       : Param_Block_Ptr;
	Index        : Entry_Member_Index;
	ECD          : ECD_Access;
	Where        : Code_Address;
	Static_Link : Data_Address
     );
     pragma import (Ada,Call_Entry_Body,"rts_call_entry_body");

    procedure Call_Task_Body(
	Self_Addr    : Data_Address;
	Where        : Code_Address;
	Static_Link  : Data_Address 
    );
     pragma import (Ada,Call_Task_Body,"rts_call_task_body");

end System.RTS.TGT.Call_Outs_Driver;
