-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.tgt.exceptions.spc,v $ 
-- $Revision: 1.8 $ $Date: 96/12/17 17:30:23 $ $Author: vdelvecc $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

with Ada.Exceptions;
with System.RTS.TGT.Frames;

package System.RTS.TGT.Exceptions is
    -- The body of this package is dependent on the representation of
    -- exception maps, etc.

    -- The body will presumably be provided by the implementor
    -- of the backend.

    package AE renames Ada.Exceptions;

    procedure Raise_Occurrence(X : in AE.Exception_Occurrence);
    -- This procedure (re)raises the given occurence;
    -- Ada.Exceptions.Exception_Identity(X) gives the exception ID 

    function Catch_Occurrence return AE.Exception_Occurrence_Access;
    pragma Import(Intrinsic, Catch_Occurrence, Link_Name => "ecatch");
    -- This function returns the current exception occurrence.
    -- This function may only be called at the very beginnning
    -- of an exception handler.
    -- It is presumably specially recognized in the backend.

    procedure Raise_At_Address(
	Where : in Address; 
	Name  : in AE.Exception_ID := Program_Error'Identity );
    -- Raises the exception at an address in the caller's caller.
    -- This is used when an exception occurs during finalization.
    -- This procedure should be called from an RTS routine which is
    -- called from generated code.  The address supplied will be
    -- in that generated code.  The exception should be raised as
    -- though RTS_Raise(Exc) were called from that address.
			
end System.RTS.TGT.Exceptions;
