-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.tgt.frames.spc,v $ 
-- $Revision: 1.11 $ $Date: 96/12/17 17:10:45 $ $Author: vdelvecc $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

package System.RTS.TGT.Frames is
    -- The body of this package is dependent on the representation
    -- of stack frames.

    -- The body will presumably be provided by the implementor
    -- of the backend.

    type Frame_ID is private;
    -- Every stack frame is identified by a unique ID
    -- It will typically be the stack pointer or frame pointer.
    -- Every master record records the Frame_ID of its stack frame.

    Null_Frame_ID : constant Frame_ID;

    function Current_Frame return Frame_ID;
    -- This function returns the current frame ID.
    -- It is called from a routine that is called from
    -- generated code.
    -- (Perhaps should be Intrinsic; perhaps should be called
    -- directly from generated code).

    function Current_Return_Address return System.Address;
    -- Returns the return address of this function's caller,
    -- i.e. the address to which the caller will return when it
    -- finishes.
    -- This function should be called from an RTS routine which is
    -- called from generated code, and should return an address
    -- in the generated code.

private
    type Frame_ID is new Address;  -- typical implementation
    pragma Import (Intrinsic, Current_Frame, Link_Name => "*CURRENT_FRAME");
    pragma Import (Intrinsic, Current_Return_Address, "*CURRENT_RETURN_ADDRESS");

    Null_Frame_ID : constant Frame_ID := Frame_ID(Null_Address);

end System.RTS.TGT.Frames;
