-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.two_dimension_queue_pkg.spc,v $ 
-- $Revision: 1.5 $ $Date: 96/06/26 18:11:01 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.RTS.Protected_Types_Pkg;      use System.RTS.Protected_Types_Pkg;

package System.RTS.Two_Dimension_Queue_Pkg is

    pragma Suppress( Elaboration_Check );

--* OVERVIEW
--  This package implements the 2nd dimension of the queues. Largely, this
--  is all large model, however some small model code is placed here as
--  well. It calls operations the System.RTS.ECD_Queue_Pkg.

--  Relocation of column occurs only in the priority case.

--  Large queue structure:
--  There is one row of ECDs sorted by (priority in the priority case, 
--  and then) by entry pair (Name_Index + Member_Index) which is a component 
--  of the ECD (that is, a lexical order).  (For non-family entry, the 
--  Member_Index is irrelevant to the RTS, but it is well-defined and
--  constant.) The Row is singly-linked using the Next_Queue component.
--  Each ECD in the row also serves as a queue head for the column of the
--  same entry pair (i.e. this is a queue for a single entry).  The columns
--  are also made of ECDs, are doubly-linked and are sorted by either FIFO
--  or priority.  These columns are managed by System.RTS.ECD_Queue_Pkg.

    procedure Add_To_Queue( Queue_Head : in out ECD_Access;
    	    	    	    ECD        : ECD_Access );
    --* EFFECTS
    --  Add an ECD to its appropriate column. Adds a column or relocate it
    --  if necessary.

    procedure Remove_First( Queue_Head  : in out ECD_Access;
            	    	    Which_Queue : in ECD_Access;
            	    	    ECD         : out ECD_Access );
    --* EFFECTS
    --  Removes and return the first ECD in Which_Queue, and potentially 
    --  unchains or relocates the column. Previous is used instead of
    --  the double link.

    procedure Remove( Queue_Head : in out ECD_Access;
		      ECD        : in ECD_Access );
    --* EFFECTS
    --  Removes a given ECD from two dimensional queue.

--DBG--    procedure Print_Queue( Queue : ECD_Access );
--DBG--    --*OVERVIEW
--DBG--    -- this routyine is for debugging purposes only
        
end System.RTS.Two_Dimension_Queue_Pkg;
