-- <HTML><BODY><H1>AWTUtil.Ada</H1><PRE>
-- Copyright 1995, Intermetrics, Inc.
--
--
-- This is to suppress the generic elaboration bit,
-- which we don't deal with well at the moment:
pragma Suppress(Elaboration_Check);

-- A kind of frame that doesn't cause HotJava to exit when the
-- frame is deleted.
--
with java.lang.String; use java.lang.String;
with java.awt.Frame; use java.awt.Frame;
with java.awt.Event; use java.awt.Event;

--<A NAME="Ind_Frame"><H2>Inf_Frame Package</H2></A>
package Ind_Frame is
    type Ind_Frame_Obj is new Frame_Obj with null record;
    type Ind_Frame_Ptr is access all Ind_Frame_Obj'Class;

    function handleEvent(x :  access Ind_Frame_Obj;
		         evt: Event_ptr) 
			 return boolean;
    pragma Export(Java, handleEvent);

    function new_Ind_Frame (title: String_ptr;
			    Obj : Ind_Frame_Ptr := null)
			   return Ind_Frame_Ptr;
    pragma Convention(Java_Constructor, new_Ind_Frame);
end Ind_Frame;

package body Ind_Frame is
    function handleEvent(x : access Ind_Frame_Obj;
			 evt:event_ptr) return boolean is
    begin
	if (evt.id = WINDOW_DESTROY) then
	       dispose(x);
	end if;
	return false;
    end;


    function new_Ind_Frame (title: String_ptr;
			    Obj : Ind_Frame_Ptr := null)
			   return Ind_Frame_Ptr is
    begin
	return Ind_Frame_Ptr(new_Frame(title,Frame_Ptr(Obj)));
    end new_Ind_Frame;

end Ind_Frame;



--
-- This is a kind of layout that lets you lay things out by hand.
-- Imagine that!
--
with java.awt.FlowLayout; use java.awt.FlowLayout;
with java.awt.Container; use java.awt.Container;
with java.lang; use java.lang;
with java.lang.system; use java.lang.system;
with java.io.printstream; use java.io.printstream;

--<A NAME="nonLayout"><H2>nonLayout Package</H2></A>
package nonLayout is
    type nonLayout_Obj is new FlowLayout_Obj with null record;
    type nonLayout_Ptr is access all nonLayout_Obj;

    procedure layoutContainer(l : access nonLayout_Obj;
		              target : Container_Ptr);

    function new_nonLayout(align : Integer := 1;  -- center
			   hgap : Integer := 5; 
			   vgap : integer := 5;
			   Obj: NonLayout_Ptr := null) 
			   return nonLayout_ptr;
    pragma Convention(Java_Constructor,  new_nonLayout);
end nonLayout;

package body nonLayout is
	
    procedure layoutContainer(l : access nonLayout_Obj;
		     target : Container_Ptr) is
    begin
	null;   -- override
    end layoutcontainer;

    function new_nonLayout(align : Integer := 1; 
			   hgap : integer := 5;
			   vgap : integer := 5;
			   Obj: NonLayout_Ptr := null) 
			   return nonLayout_ptr is
	begin
	   return nonLayout_ptr(new_FlowLayout(align,hgap,vgap,
					FlowLayout_ptr(Obj)));
	end new_nonLayout;

end nonLayout;


with java.awt.Event; use java.awt.Event;
with java.awt.Panel; use java.awt.Panel;
with java.awt.Container; use java.awt.Container;
with java.awt.Color; use java.awt.Color;
with java.awt.Frame; use java.awt.Frame;
with Ind_Frame; use Ind_Frame;

--<A NAME="typeablePanel"><H2>typeablePanel Package</H2></A>
generic
    with procedure handleKey(ch : Character);
package typeablePanel is
    type typeablePanel_Obj is new Panel_Obj with null record;
    type typeablePanel_Ptr is access all typeablePanel_Obj'class;

    function keyDown(Obj : access typeablePanel_Obj;
        evt : Event_Ptr;
        key : Integer)
      return Boolean;
    pragma Export(Java, keyDown);

    function new_TypeablePanel(parent : Ind_Frame_Ptr;
	 			 bg : Color_Ptr;
				 w : Integer; 
				 h : Integer;
				 Obj: TypeablePanel_Ptr := null)
				 return TypeablePanel_Ptr ;
    pragma Convention(Java_Constructor, new_TypeablePanel);

end typeablePanel;

with Interfaces.Java; use Interfaces.Java;
with java.awt.Frame; use java.awt.Frame;
with java.lang.system; use java.lang.system;
with java.io.printstream; use java.io.printstream;
with java.awt.Component;  use java.awt.Component;
package body typeablePanel is
    function keyDown(Obj : access typeablePanel_Obj;
        evt : Event_Ptr;
        key : Integer) return boolean is
    begin	
	handleKey(Character'Val(key));
        return true;
    end keyDown;

    function new_TypeablePanel(parent : Ind_Frame_Ptr;
	 			 bg : Color_ptr;
				 w : Integer; 
				 h : Integer; 
				 Obj: TypeablePanel_Ptr := null)
				 return TypeablePanel_Ptr   is
	Result : TypeablePanel_Ptr := 
		TypeablePanel_Ptr(add(container_ptr(parent),
				  +"Center",
				  Component_Ptr(New_Panel(
						Panel_ptr(Obj)))));

    begin
	SetBackground(Result, bg);
	resize(Result,w,h);
	return result;
    end new_TypeablePanel;

end typeablePanel;
--</PRE></BODY></HTML>

