--   Copyright 1995, Intermetrics, Inc.
--
--
-- This is to suppress to generic elaboration bit,
-- which we don't deal with well at the moment:
pragma Suppress(Elaboration_Check);

-- cbButton
--   This package implements an awt Button with a callback function
--   specifiable via a generic parameter.  Each button has some 
--   associated state which is passed to the callback routine.
--   

with java.lang.String; use java.lang.String;
with java.awt.Container; use java.awt.Container;
with java.awt.Component; use java.awt.Component;
with java.awt.Button; use java.awt.Button;
with java.awt.Event; use java.awt.Event;
with java.lang; use java.lang;
generic
    type callbackInfo is private;
    with procedure handleButton(info : callbackInfo);
package cbButton is
    type cbButton_Obj is new Button_Obj with record
        cb : callbackInfo;
    end record;
    type cbButton_Ptr is access all cbButton_Obj'class;

    function action(Obj : access cbButton_Obj;
        evt : Event_Ptr;
        what : Object_Ptr)
      return Boolean;

    function New_cbButton(Label : String_Ptr; 
			  Parent : Container_Ptr; 
			  info : callbackInfo;
			  Obj : cbButton_ptr := null)
	 	 	  return  component_ptr;
end cbButton;


with java.lang.System; use java.lang.System;
with java.io.PrintStream; use java.io.PrintStream;
package body cbButton is
    function New_cbButton(label : String_Ptr;
			  parent : Container_Ptr; 
			  info : callbackInfo;
			  Obj : cbButton_ptr := null)
                          return component_Ptr is
	button : cbButton_Ptr := new cbButton_Obj; 
    begin
	button.cb := info;
	setlabel(Button_ptr(button), label);
	return  add(parent,  Component_ptr(button));
    end;

    function action(Obj : access cbButton_Obj;
		    evt : Event_Ptr;
		    what : Object_Ptr) 
	     return Boolean is
    begin
	handleButton(Obj.cb);
	return true;
    end;
end;
