with Ada.Calendar;
with Ada_Store.Station;

package Ada_Store.Log is

  type Element		is tagged private;
  
  function To_String
    (Log_Element : in Element)
     return String;
	   
  procedure Open_Log;

  procedure Put
    (Element_In	: in out Element'Class);

private
  type Sequence_Number 	is new Long_Integer range 1 .. Long_Integer'Last;

  type Element 		is tagged 
    record
      Sequence 	    : Sequence_Number;
      Calendar_Time : Ada.Calendar.Time;
      Station_ID    : Station.Identifier;
    end record;

end Ada_Store.Log;
