with Ada_Store.PoST.Device; 
with Ada_Store.PoST.Device.Display; 
with Ada_Store.PoST.Device.Printer; 
with Ada_Store.PoST.Device.Scanner; 
with Ada_Store.PoST.Device.Keyboard; 
with Ada_Store.PoST.Device.Alarm; 

package Ada_Store.PoST.Configuration is

   type Display_Units  is (Cashier, Customer);
   type Printer_Units  is (Epson);
   type Scanner_Units  is (Flat_Bed);

   Displays  : array (Display_Units)  of Device.Display.Instance;
   Printers  : array (Printer_Units)  of Device.Printer.Instance;
   Scanners  : array (Scanner_Units)  of Device.Scanner.Instance;
   Keyboard0 : Device.Keyboard.Instance;
   Alarm0    : Device.Alarm.Instance;

end Ada_Store.PoST.Configuration;
