package body Ada_Store.PoST.Device is

   procedure Open
     (Device  : in out Instance'Class;
      Unit_ID : in     Unit) is
   begin
      if Device.Current_Status = Closed then
	 Device.Current_Status := Idle;
	 Device.Unit_ID        := Unit_ID;
	 
	 Open(Device);
      else
	 raise Incorrect_Status;
      end if;
   end Open;

   procedure Close
     (Device : in out Instance) is
   begin
      if Device.Current_Status /= Closed or
	Device.Current_Status /= Locked then
	 Device.Current_Status := Closed;
      else
	 raise Incorrect_Status;
      end if;
   end Close;

   procedure Lock
     (Device : in out Instance) is
   begin
      if Device.Current_Status /= Locked then
	 Device.Current_Status := Locked;
      else
	 raise Incorrect_Status;
      end if;
   end Lock;

   procedure UnLock
     (Device : in out Instance) is
   begin
      if Device.Current_Status = Locked then
	 Device.Current_Status := Idle;
      else
	 raise Incorrect_Status;
      end if;
   end unLock;

   procedure ReStart
     (Device : in out Instance) is
   begin
      if Device.Current_Status = Off_Line or
	Device.Current_Status = Error then
	 Device.Current_Status := Idle;
      else
	 raise Incorrect_Status;
      end if;
   end ReStart;

   function  Current_Mode
     (Device : in Instance)
      return Device_Mode is
   begin
      return Device.Current_Mode;
   end Current_Mode;

   function  Current_Status
     (Device : in Instance)
      return Device_Status is
   begin
      return Device.Current_Status;
   end Current_Status;
   
   function  Unit_ID
     (Device		: in    Instance) return Unit is
   begin
      return Device.Unit_ID;
   end Unit_ID;
   
   
end Ada_Store.PoST.Device;
