package Ada_Store.PoST.Input_Queue is

   type Input_Action is ( Unknown,
			  Enter, Cancel, 
			  Sign_On, Sign_Off, Close_Down,
			  Item_Sale, Department_Sale, Price_Enquiry, Subtract_Line, 
			  Sub_Total, 
			  Cash_Payment, Cheque_Payment, Card_Payment );

   Max_Input_Text : constant Positive := 40;

   type Message is 
      record
	 Action : Input_Action := Unknown;
	 Input  : String(1 .. Max_Input_Text);
	 Length : Natural := 0;
      end record;

   type Message_Ptr is access all Message;

   procedure Append
     (Message : in Message_Ptr);

   function  Get
     (Wait : in Boolean	:= False)
      return Message_Ptr;

   function  Peek
     (Wait : in Boolean	:= False)
     return Message_Ptr;

end Ada_Store.PoST.Input_Queue;      

