with Ada_Store.PoST.Input_Queue;

package Ada_Store.PoST.Device.Alarm is

   type Instance 	is new Ada_Store.PoST.Device.Instance with private;

   procedure Open
     (Alarm : in out Instance);

   type Sound_Type is ( Information, Warning, Error, Fatal );

   procedure Sound
     (Alarm : in Instance;
      Like  : in Sound_Type);
     
   procedure Flush
     (Alarm	 : in out Instance;
      Flush_Mode : in     Device_Mode);

   procedure Accept_Input
     (Alarm  : in out Instance;
      Input  : in     Input_Queue.Message_Ptr);
	
private
   type Instance 	is new Ada_Store.PoST.Device.Instance with null record;

end Ada_Store.PoST.Device.Alarm;
