with Ada_Store.PoST.Input_Queue;

package Ada_Store.PoST.Device.Printer is
	
   type Instance 	is new Ada_Store.PoST.Device.Instance with private;

   type Printer_Status 	is ( Ok, Paper_Low, Paper_Out, Ink_Out );

   type Print_Station   is ( Receipt, Journal, Slip );

   function  Current_Status
     (Device : in Instance)
      return Printer_Status;
   
   function  Has_Station
     (Printer : in Instance;
      Station : in Print_Station)
       return Boolean;

   procedure Open
     (Printer : in out Instance);

   function  Lines
     (Printer : in Instance;
      Station : in Print_Station)
       return Integer;

   function  Columns
     (Printer : in Instance;
      Station : in Print_Station)
      return Positive;

   procedure Write
     (Printer : in out Instance;
      Station : in     Print_Station;
      Text    : in     String);

   procedure Cut_Paper
     (Printer : in out Instance;
      Station : in     Print_Station); 

   procedure Flush
     (Printer	 : in out Instance;
      Flush_Mode : in     Device_Mode);

   procedure Accept_Input
     (Printer : in out Instance;
      Input   : in     Input_Queue.Message_Ptr);
	
private
   type Instance 	is new Ada_Store.PoST.Device.Instance with 
      record
         Line           : Integer := 0;
      end record;

end Ada_Store.PoST.Device.Printer;
