with Ada_Store.PoST.Input_Queue;

package Ada_Store.PoST.Device.Scanner is

   type Instance 	is new Ada_Store.PoST.Device.Instance with private;

   type Laser_Status 	is ( On, Off, Unknown );
   
   function  Current_Status
     (Scanner : in Instance)
      return Laser_Status;
    
   procedure Open
     (Scanner : in out Instance);

   procedure Flush
     (Scanner	 : in out Instance;
      Flush_Mode : in     Device_Mode);

   procedure Accept_Input
     (Scanner : in out Instance;
      Input   : in     Input_Queue.Message_Ptr);
	
private
   type Instance 	is new Ada_Store.PoST.Device.Instance with null record;

end Ada_Store.PoST.Device.Scanner;
