package body Ada_Store.Support.IPC is

   protected body Mutex is

      entry Acquire when not Locked is
      begin
	 Locked := True;
      end Acquire;

      procedure Release is
      begin
	 Locked := False;
      end Release;

   end Mutex;

   protected body Semaphore is
      
      entry Wait when Signals > 0 is
      begin
	 if Auto_Reset then
	    requeue Reset;
	 end if;
      end Wait;

      entry Signal when True is
      begin
	 Signals := Signals + 1;
      end Signal;

      entry Reset when Signals > 0 is
      begin
	 Signals := Signals - 1;
      end Reset;

   end Semaphore;

end Ada_Store.Support.IPC;










