generic

   type Element_Type is private;

package Ada_Store.Support.List is

   type Instance is private;

   procedure Append
     (List    : access Instance;
      Element : in     Element_Type);

   function  Get
     (List    : access Instance) return Element_Type;

   function  Peek
     (List    : access Instance) return Element_Type;

   List_Empty : exception;

private
   type Element_Holder;
   type List_Ptr       is access Element_Holder;

   type Element_Holder is
      record
	 Actual   : Element_Type;
	 Next     : List_Ptr := null;
      end record;

   type Instance is 
     record
	Head : List_Ptr := null;
	Tail : List_Ptr := null;
     end record;

end Ada_Store.Support.List;      

