-- ***************************************************************************
-- *                     Complex_Loops.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This example corresponds to example 2.2 in the text and
-- *    demonstrates the use of named loops to handle complex nested
-- *    looping issues.
-- * Inputs:  Will try and read this file as input (check file exists).
-- * Outputs: None.
-- ***************************************************************************
with Ada.Text_IO; use Ada.Text_IO;

procedure Complex_Loops is
   File_Handle : File_Type;
   Input_Line  : String(1 .. 255);
   Last_Char   : Natural;
   Null_Char   : constant Character := Character'Val(0);
   Percent_Char: constant Character := '%';
begin
   Open(File => File_Handle,
        Mode => In_File,
        Name => "Complex.adb");

   Get_Line(File => File_Handle, Item => Input_Line, Last => Last_Char);

   Main_Loop:
      while not End_Of_File(File => File_Handle) loop

         for Char_Index in 1 .. Last_Char loop

            exit           when Input_Line(Char_Index) = Null_Char;
            exit Main_Loop when Input_Line(Char_Index) = Percent_Char;
         end loop;
 
         Get_Line(File => File_Handle, Item => Input_Line, Last => Last_Char);

      end loop Main_Loop;

   Close(File => File_Handle);

end Complex_Loops;
