-- ***************************************************************************
-- *                         Access_Tests.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: Examples of pool-specific access types using the linked list
-- *    example (3.2) from the text.
-- * Inputs:  None.
-- * Outputs: None.
-- ***************************************************************************

procedure Access_Tests1 is

   type Element_Type is new Integer;

   type Element_Holder;
   type List_Ptr is access Element_Holder;

   type Element_Holder is
      record
         Actual : Element_Type;
         Next   : List_Ptr := null;
      end record;

   type List is
      record
         Head : List_Ptr := null;
         Tail : List_Ptr := null;
      end record;

   Actual_1 : Element_Type := 1;
   Actual_2 : Element_Type := 3;
   Actual_3 : Element_Type := 5;

   Temp_Ptr : List_Ptr;
   My_List  : List;
begin

   Temp_Ptr := new Element_Holder'(Actual => Actual_1, Next => null);
   My_List.Tail := Temp_Ptr;
   My_List.Head := My_List.Tail;

   Temp_Ptr := new Element_Holder'(Actual => Actual_2, Next => null);
   My_List.Tail.Next := Temp_Ptr;
   My_List.Tail := My_List.Tail.Next;

   Temp_Ptr := new Element_Holder'(Actual => Actual_3, Next => null);
   My_List.Tail.Next := Temp_Ptr;
   My_List.Tail := My_List.Tail.Next;
end Access_Tests1;
