-- ***************************************************************************
-- *                         Access_Tests.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: Examples of Ada95 general access types and access levels. The
-- *    examples are designed not to compile, they follow the order of section
-- *    3.5.2.1.
-- * Inputs:  None.
-- * Outputs: This example does not compile.
-- ***************************************************************************

procedure Access_Tests3 is
begin

   First_Test:
      declare
         type Data_Ptr is access all Integer;

         procedure Test1(Data : Data_Ptr) is
         begin
            null;
         end Test1;

         procedure Test2 is
            Data : aliased Integer;
         begin
            Test1(Data'Access); -- illegal
            -- Test1(Data'Unchecked_Access); -- would be legal
         end Test2;

      begin
         Test2;
      end First_Test;

   Second_Test:
      declare
         type Data_Ptr is access all Integer;

         function Get_Data return Data_Ptr is
            Data : aliased Integer;
         begin
            return Data'Access; -- illegal
         end Get_Data;

      begin
         null;
      end Second_Test;

   Third_Test:
      declare
         type Data_Ptr is access all Integer;

         procedure Test1(Data : Data_Ptr) is
         begin
            null;
         end Test1;

         Data : aliased Integer;

         procedure Test2 is
         begin
            Test1(Data'Access); -- now legal
         end Test2;

      begin
         Test2;
      end Third_Test;

   Fourth_Test:
      declare
         type Data_Ptr is access all Integer;

         procedure Test0(Data : Data_Ptr) is
         begin
            null;
         end Test0;

         procedure Test1(Data : access Integer) is
         begin
            Test0(Data_Ptr(Data));
         end Test1;

         procedure Test2 is
            Data : aliased Integer;
         begin
            Test1(Data'Access);
         end Test2;

      begin
         Test2;
      end Fourth_Test;

end Access_Tests3;
