-- ***************************************************************************
-- *                        Print_Array.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: Examples based around the example 3.1 in the text, printing
-- *    the contents of arrays.
-- * Inputs:  None.
-- * Outputs: Prints the contents of a simple array.
-- ***************************************************************************

with Ada.Text_IO; use Ada.Text_IO;

procedure Print_Array is

   type Vector is array (Integer range <>) of Float;
   subtype Small_Vector is Vector(0 .. 2);

   procedure Print_Vector(Print_This : in Vector);
   procedure Print_Vector(Print_This : in Vector) is
   begin
      for Item in Print_This'Range loop
         Put("Item ");
         Put(Integer'Image(Item));
         Put(" = ");
         Put(Float'Image(Print_This(Item)));
         New_Line;
      end loop;
   end Print_Vector;

   Results : Small_Vector := (3, 1, 2);
begin

   Print_Vector(Results);

end Print_Array;
