-- ***************************************************************************
-- *                         Animal.ads
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This is the first example of a tagged type, and represents
-- *    the C++ class animal.
-- * Inputs:  None.
-- * Outputs: None.
-- ***************************************************************************

package Animal is
   type Instance is abstract tagged private;

   procedure Make_A_Sound
     (Animal : in Instance'Class)
      is abstract;

   function  Name
     (Animal : in Instance)
      return String;

   function  Class_Name return String;

private
   type Instance is abstract tagged 
      record
         Name  : String(1 .. 30);
      end record;

   Private_Class_Name : constant String := "Animal";
end Animal;
