-- ***************************************************************************
-- *                         Nice_And_Safe.ads
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This is a safe package, the data is held in the private
-- *    part and so cannot be altered, or can it?
-- * Inputs:  None.
-- * Outputs: None.
-- ***************************************************************************

package Nice_And_Safe is
   type Instance is tagged private;

   function Access_My_Data
     (Object : in Instance)
      return Integer;

private
   type Instance is tagged
      record
         Private_Data : Integer;
      end record;

end Nice_And_Safe;
