-- ***************************************************************************
-- *                         Echo_Args.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This simple, though useful program simply writes the
-- *    arguments provided to it.
-- * Inputs:  None.
-- * Outputs: whatever else you put on the command line.
-- ***************************************************************************

with Ada.Text_IO;
with Ada.Command_Line;
 
procedure Echo_Args is
begin
   Ada.Text_IO.Put_Line("Program " & 
    		        Ada.Command_Line.Command_Name & 
		        " called with " &
			Natural'Image(Ada.Command_Line.Argument_Count) &
			" arguments:");

   for I in 1 .. Ada.Command_Line.Argument_Count loop

      Ada.Text_IO.Put_Line("    " & Ada.Command_Line.Argument(I));
   end loop;

   Ada.Command_Line.Set_Exit_Status(Ada.Command_Line.Success);
end Echo_Args;
