-- ***************************************************************************
-- *                         Pool_Test.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This tests the pool specified in Shared_Pool.ads. It also
-- *    demonstrates how to assign a type to a specific pool.
-- * Inputs:  None.
-- * Outputs: None.
-- ***************************************************************************

with Shared_Pool;

procedure Pool_Test is

   Pool_Name       : aliased constant String := "stats";
   Statistics_Pool : Shared_Pool.Pool(1024, Pool_Name'Unchecked_Access);

    type App_Statistics is
      record
         Ex : Integer;
      end record;
    type App_Statistics_Ptr is access all App_Statistics;

   for App_Statistics_Ptr'Storage_Pool use Statistics_Pool;

   Shared_Statistics : App_Statistics_Ptr;
begin
   Shared_Statistics := new App_Statistics;
end Pool_Test;
