-- ***************************************************************************
-- *                         PutString_Binding.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This is a "thick" binding, one which encapsulates the call
-- *    to the underlying interface.
-- * Inputs:  None.
-- * Outputs: None.
-- ***************************************************************************

with Interfaces.C.Strings;
package body PutString_Binding is

   procedure PutString(S : Interfaces.C.Strings.chars_ptr);
   pragma Import(C, PutString, "putstring");

   procedure Put(S : String) is
      C_Str     : Interfaces.C.Strings.chars_ptr;
   begin
      C_Str := Interfaces.C.Strings.New_String(S);
      PutString(C_Str);
      Interfaces.C.Strings.Free(C_Str);
   end Put;

end PutString_Binding;
