-- ***************************************************************************
-- *                         Task_Test.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This example shows the use of the Ada.Task_Attributes
-- *    package which allows you to add arbitrary attributes to tasks.
-- * Inputs:  None.
-- * Outputs: messages from procedure body.
-- ***************************************************************************

with Ada.Task_Attributes;
with Ada.Text_IO;
use  Ada;

procedure Task_Test is

   package Threaded is new Task_Attributes(Boolean,
					              True);
   task type X is
      entry Start;
   end X;

   task body X is
   begin
      Threaded.Set_Value(False);
      accept Start do
	    null;
      end Start;
   end X;

   An_X : X;
begin
   Text_IO.Put_Line("Current Task Value = " &
		         Boolean'Image(Threaded.Value));

   Text_IO.Put_Line("An_X Value = " &
		         Boolean'Image(Threaded.Value(An_X'Identity)));
end Task_Test;
