With Ada.Unchecked_Conversion;
with Win32.Wingdi;
with Win32.Utils;
with Windows.Data;
package body Windows.Child_Routines is
  use type Win32.Uint;
  use type Win32.Wparam;

  Bool_Result : Win32.Bool;

  function About_Dialog
    (Dialog_Handle : Win32.Windef.Hwnd;
     Message       : Win32.Uint;
     Wparam        : Win32.Wparam;
     Lparam        : Win32.Lparam) return Win32.Bool is
  begin

    case
      Message is

      when
        Win32.Winuser.Wm_Initdialog =>
   
        return (1);

      when
        Win32.Winuser.Wm_Command    =>

        case
          Win32.Utils.Loword
            (Win32.Dword
               (Wparam)) is
         
          when
            Win32.Winuser.Idok     |
            Win32.Winuser.Idcancel =>
        
            Bool_Result :=
              Win32.Winuser.Enddialog
                (Hdlg    =>
                  Dialog_Handle,
                 Nresult =>
                  0);

            return (1);

          when
            others =>

            return (0);

        end case;

      when
        others =>

        return (0);

    end case;      

  end About_Dialog;

end Windows.Child_Routines;

