with Ada.Text_Io;
with Ada.Unchecked_Conversion;
with Interfaces.C.Strings;
with System;
with Win32.Commdlg;
with Win32.Stdlib;
with Win32.Winbase;
with Win32.Windef;
with Win32.Wingdi;
with Win32.Winmain;
with Win32.Utils;
with Win32.Winuser;
with Windows.Child_Routines;
with Windows.Data;
with PopPad3;
with Windows.Pop.File;
with Windows.Pop.Find;
with Windows.Pop.Font;
with Windows.Pop.Print;
package body Windows.Routines is
  use type Interfaces.C.Size_T;
  use type System.Address;
  use type Win32.Bool;
  use type Win32.Dword;
  use type Win32.Int; 
  use type Win32.Long;
  use type Win32.Lresult;
  use type Win32.Uint;

--  Paint_Record           : aliased win32.Winuser.Paintstruct;

--  Accelerator_Handle     : Win32.Windef.Hwnd;

  Null_String             : constant String(1 ..1) :=(others => Character'Val(0));

  Null_Text               : constant Interfaces.C.Strings.Chars_Ptr := 
    Interfaces.C.Strings.New_String
      (Str =>
        Null_String);

  About_Text              : constant Interfaces.C.Strings.Chars_Ptr := 
    Interfaces.C.Strings.New_String
      (Str =>
        "AboutBox");

  Edit_Text              : constant Interfaces.C.Strings.Chars_Ptr := 
    Interfaces.C.Strings.New_String
      (Str =>
        "edit");

  Edit_Control_Text      : constant Interfaces.C.Strings.Chars_Ptr := 
    Interfaces.C.Strings.New_String
      (Str =>
        "Edit control out of space");

  Untitled_Text          : constant Interfaces.C.Strings.Chars_Ptr := 
    Interfaces.C.Strings.New_String
      (Str =>
        "(untitled)");

  File_Name_Text         : constant String(1 .. Integer(Win32.Stdlib.Max_Path)) :=
    (others => ' ');
    
  File_Name              : Interfaces.C.Strings.Chars_Ptr := 
    Interfaces.C.Strings.New_String
      (Str =>
        File_Name_Text);

  Title_Name_Text        : constant String(1 .. Integer(Win32.Stdlib.Max_Fname) + Integer(Win32.Stdlib.Max_Ext)) :=
    (others => ' ');
    
  Title_Name             : Interfaces.C.Strings.Chars_Ptr := 
    Interfaces.C.Strings.New_String
      (Str =>
        Title_Name_Text);

  Edit_Id                : Win32.Int;

  Offset                 : Windows.Pop.Find.Int_Ptr := new Win32.Int'(0);

  Edit_WIndow_Handle     : Win32.Windef.Hwnd;

  Modeless_Dialog_Handle : Win32.Windef.Hwnd;

  Accelerator_Handle     : Win32.Windef.Haccel;
 
  Window_Class           : aliased Win32.Winuser.Wndclass;

  Message                : aliased Win32.Winuser.Msg;

--  True                   : constant Win32.Bool := 1;

  Instance               : Win32.Windef.Hinstance;

  Integer_Result         : Win32.Int;
     
  Need_Save              : Win32.Int := Win32.False;

  Dword_Result           : Win32.Dword;

  Uint_Result            : Win32.Uint;

  Bool_Result            : Win32.Bool;
                     
  Boolean_Result         : Boolean;
                     
  Long_Result            : Win32.Long;

  L_Result               : Win32.Lresult;

  Atom_Result            : Win32.Windef.Atom;

  Pstr_Result            : Win32.Pstr;

  Short_Result           : Win32.Short;

  Message_Find_Replace   : Win32.Uint;

  Hwnd_Result            : Win32.Windef.Hwnd;

--  Device_Context_Result  : Win32.Windef.Hdc;

  function
    Convert_Chars_Ptr_To_Lpcstr is new
      Ada.Unchecked_Conversion
        (Source =>
          Interfaces.C.Strings.Chars_Ptr,
         Target =>
          Win32.Lpcstr);


  procedure
    Ok_Message
      (Window_Handle :
        Win32.Windef.Hwnd;
       Message       :
        String;
       Title_Name    :     
        Interfaces.C.Strings.Chars_Ptr) is

    Buffer : Interfaces.C.Strings.Chars_Ptr; 

  begin

Ada.Text_Io.Put_Line
  ("Inside Ok_Message");

    if
      Interfaces.C.Strings.Value
        (Item =>
          Title_Name)(1) /= Character'Val(0) then

Ada.Text_Io.Put_Line
  ("Title Name was null");

      Buffer :=
        Interfaces.C.Strings.New_String
          (Str =>
            Message &
            Interfaces.C.Strings.Value
              (Item =>
                Title_Name));

    else

Ada.Text_Io.Put_Line
  ("Title_Name Was not null");

      Buffer :=
        Interfaces.C.Strings.New_String
          (Str =>
            Message &
            Interfaces.C.Strings.Value
              (Item =>
                Untitled_Text));

    end if;

Ada.Text_Io.Put_Line
  ("Buffer = " &
   Interfaces.C.Strings.Value
    (Item =>
      Buffer));

    Integer_Result :=
      Win32.Winuser.Messagebox
        (Hwnd      =>
          Window_Handle,
         Lptext    =>
          Convert_Chars_Ptr_To_Lpcstr
            (S =>
              Buffer),
         Lpcaption =>
          Convert_Chars_Ptr_To_Lpcstr
            (S =>
              Windows.Data.Class_Name),
         Utype     =>
          Win32.Uint
           (Win32.Winuser.Mb_Ok) or
          Win32.Uint
           (WIn32.Winuser.Mb_Iconquestion));

    Interfaces.C.Strings.Free
      (Item =>
        Buffer);

  end;

  procedure
    Do_Caption
      (Window_Handle :
        Win32.Windef.Hwnd;
       Title_Name    :     
        Interfaces.C.Strings.Chars_Ptr) is

    Buffer : Interfaces.C.Strings.Chars_Ptr; 

  begin

    if
      Interfaces.C.Strings.Value
        (Item =>
          Title_Name)(1) /= Character'Val(0) then

      Buffer :=
        Interfaces.C.Strings.New_String
          (Str =>
            Interfaces.C.Strings.Value
              (Item =>
                Windows.Data.Class_Name) &
            "-"                          &
            Interfaces.C.Strings.Value
              (Item =>
                Title_Name));

    else

      Buffer :=
        Interfaces.C.Strings.New_String
          (Str =>
            Interfaces.C.Strings.Value
              (Item =>
                Windows.Data.Class_Name) &
            "-"                          &
            Interfaces.C.Strings.Value
              (Item =>
                Untitled_Text));
    end if;

    Bool_Result :=
      Win32.Winuser.Setwindowtext
        (Hwnd     =>
          Window_Handle,
         Lpstring =>
          Convert_Chars_Ptr_To_Lpcstr
            (S =>
              Buffer));

    Interfaces.C.Strings.Free
      (Item =>
        Buffer);

  end;

  function
    Ask_About_Save
      (Window_Handle :
        Win32.Windef.Hwnd;
       Title_Name    :     
        Interfaces.C.Strings.Chars_Ptr) return Win32.Int is

    Buffer : Interfaces.C.Strings.Chars_Ptr; 

    Temp_Text : String := "Save current changes in";

  begin

    if
      Interfaces.C.Strings.Value
        (Item =>
          Title_Name)(1) /= Character'Val(0) then

      Buffer :=
        Interfaces.C.Strings.New_String
          (Str =>
            Temp_Text &
            Interfaces.C.Strings.Value
              (Item =>
                Title_Name));

    else

      Buffer :=
        Interfaces.C.Strings.New_String
          (Str =>
            Temp_Text &
            Interfaces.C.Strings.Value
              (Item =>
                Untitled_Text));
    end if;

    Integer_Result :=
      Win32.Winuser.Messagebox
        (Hwnd      =>
          Window_Handle,
         Lptext    =>
          Convert_Chars_Ptr_To_Lpcstr
            (S =>
              Buffer),
         Lpcaption =>
          Convert_Chars_Ptr_To_Lpcstr
            (S =>
              Windows.Data.Class_Name),
         Utype     =>
          Win32.Uint
            (Win32.Winuser.Mb_Yesnocancel) or
          Win32.Uint
            (Win32.WInuser.Mb_Iconquestion));
    
    if
      Integer_Result =
      Win32.Winuser.Idyes then

      if 
        Win32.Winuser.Sendmessage
          (Hwnd   =>
            Window_Handle,
           Msg    =>
            Win32.Winuser.Wm_Command,
           Wparam =>
            Win32.Wparam
              (Poppad3.Idm_Save),
           Lparam =>
            0) = 0 then

        Integer_Result :=
          Win32.Winuser.Idcancel;

      end if;

    end if;

    Interfaces.C.Strings.Free
      (Item =>
        Buffer);

    return
      Integer_Result;
 
  end;

  procedure Main_Windows_Message_Loop is
  begin

    while 
      (Win32.Winuser.Getmessage 
	    (Lpmsg => 
          Message'Access,
         Hwnd  => 
          null, 
	     Wmsgfiltermin => 
          Windows.Data.Message_Filter_Minimum,
	     Wmsgfiltermax => 
          Windows.Data.Message_Filter_Maximum) /= 0) loop
	 
      if
        Modeless_Dialog_Handle = 
        null or
        Win32.Winuser.Isdialogmessage
          (Hdlg  =>
            Modeless_Dialog_Handle,
           Lpmsg =>
            Message'Access) = 0 then

        if 
          Win32.Winuser.Translateaccelerator
            (Hwnd  =>
              Windows.Data.Window_Handle,
             Hacctable =>
              Win32.Windef.Haccel
                (Accelerator_Handle),
             Lpmsg =>
              Message'Access) = 0 then

          Bool_Result := 
            Win32.Winuser.Translatemessage
	      (Lpmsg => 
                Message'Access);
	 
          Long_Result := 
            Win32.Winuser.Dispatchmessage
              (Lpmsg => 
                Message'Access);
      	 
        end if;

      end if;

    end loop;

  end Main_Windows_Message_Loop;

  function Main
    (Instance          : Win32.Windef.Hinstance;
     Previous_instance : Win32.Windef.Hinstance;
     Command_Line      : Win32.Pcstr;
     Show_Command      : Win32.Int ) return Win32.Uint is

    function Convert_Pcstr_To_Lpvoid is new
      Ada.Unchecked_Conversion
        (Source =>
          Win32.Pcstr,
         Target =>
          Win32.Lpvoid);

  begin

    if
      Previous_Instance = System.Null_Address then
        Window_Class :=      
          (Style         => 
            Windows.Data.Window_Class_Style,
	       Lpfnwndproc   => 
            Windows.Routines.Main_Windows'Access, 
	       Cbclsextra    => 
            Windows.Data.Window_Class_Cbclsextra,
	       Cbwndextra    => 
            Windows.Data.Window_Class_Cbwndextra,
	       Hinstance     => 
            Instance,
	       Hicon         => 
            Win32.Winuser.Loadicon
              (Hinstance => 
                Instance,
               Lpiconname =>
                Convert_Chars_Ptr_To_Lpcstr
                  (S =>
                    Windows.Data.Class_Name)),
	       Hcursor       => 
            Windows.Data.Window_Class_Cursor,
	       Hbrbackground =>
            Windows.Data.Window_Class_Background,
	       Lpszmenuname  => 
            Convert_Chars_Ptr_To_Lpcstr
              (S =>
                Windows.Data.Class_Name),
	       Lpszclassname => 
            Convert_Chars_Ptr_To_Lpcstr
              (S => 
                Windows.Data.Class_Name));

        Atom_Result :=
	      Win32.winuser.Registerclass
	        (Lpwndclass => 
              Window_Class'Access);

    end if;

    Windows.Data.Window_Handle := 
      Win32.Winuser.Createwindow
	    (Lpclassname => 
          Convert_Chars_Ptr_To_Lpcstr
            (S => 
              Windows.Data.Class_Name),
         Lpwindowname => 
          null,
         Dwstyle      => 
          Windows.Data.Window_Style,
         X            => 
          Windows.Data.Window_Horizontal_Start, 
         Y            => 
          Windows.Data.Window_Vertical_Start,
         Nwidth       => 
          Windows.Data.Window_Width,
         Nheight      => 
          Windows.Data.Window_Height,
         Hwndparent   => 
          Windows.Data.Window_Parent,
         Hmenu        => 
          Windows.Data.Window_Menu,
         Hinstance    => 
          Instance,
         Lpparam      => 
          Convert_Pcstr_To_Lpvoid
            (S =>
              Command_Line));
      
    Bool_Result := 
      Win32.Winuser.Showwindow
        (Hwnd     => 
          Windows.Data.Window_Handle, 
	 Ncmdshow =>
          Win32.Winmain.Get_Ncmdshow);

    Bool_Result := 
      Win32.Winuser.Updatewindow
        (Hwnd => 
          Windows.Data.Window_Handle);

    Accelerator_Handle :=
      Win32.Winuser.Loadaccelerators
        (Hinstance   =>
          Instance,
         Lptablename =>
          Convert_Chars_Ptr_To_Lpcstr
            (S =>
              Windows.Data.Class_Name));

    Windows.Routines.Main_Windows_Message_Loop;

    return 
      Message.Wparam;

  end Main;

   function Main_Windows
     (Window_Handle : Win32.Windef.Hwnd;
      Message       : Win32.Uint;
      Wparam        : Win32.Wparam;
      Lparam        : Win32.Lparam) return Win32.Lresult is

     function Convert_Lparam_To_Lpcreatestruct is new
     Ada.Unchecked_Conversion
       (Source =>
         Win32.Lparam,
        Target =>
         Win32.Winuser.Lpcreatestruct);

     function Convert_Int_To_Hmenu is new
       Ada.Unchecked_Conversion
         (Source =>
           Win32.Int,
          Target =>
           Win32.Windef.Hmenu);

     function Convert_Address_To_Lpcstr is new
       Ada.Unchecked_Conversion
         (Source =>
           System.Address,
          Target =>
           Win32.Lpcstr);

     function Convert_Address_To_Lparam is new
       Ada.Unchecked_Conversion
         (Source =>
           System.Address,
          Target =>
           Win32.Lparam);

     function Convert_Address_To_Wparam is new
       Ada.Unchecked_Conversion
         (Source =>
           System.Address,
          Target =>
           Win32.Wparam);

     Enabled      : Win32.Uint;

     Begin_Select : Win32.Uint;

     End_Select   : Win32.Uint;

     function Convert_Lpvoid_To_Lpcstr is new
       Ada.Unchecked_Conversion
         (Source =>
           Win32.Lpvoid,
          Target =>
           Win32.Lpcstr);

     function Convert_Chars_Ptr_To_Lpstr is new
       Ada.Unchecked_Conversion
         (Source =>
           Interfaces.C.Strings.Chars_Ptr,
          Target =>
           Win32.Lpstr);

     function
       Convert_Wparam_To_Hmenu is new
         Ada.Unchecked_Conversion
           (Source =>
             Win32.Wparam,
            Target =>
             Win32.Windef.Hmenu);

     function
       Convert_Int_Ptr_To_Lparam is new
         Ada.Unchecked_Conversion
           (Source =>
             Windows.Pop.Find.Int_Ptr,
            Target =>
             Win32.Lparam);

   begin

      case Message is

	    when
          Win32.Winuser.Wm_Create =>

          Instance := 
            Convert_Lparam_To_Lpcreatestruct
              (S =>
                Lparam).Hinstance; 

          Edit_Window_Handle := 
            Win32.Winuser.Createwindow
              (Lpclassname => 
                Convert_Chars_Ptr_To_Lpcstr
                  (S => 
                    Edit_Text),
               Lpwindowname => 
                null,
               Dwstyle      => 
                Win32.Winuser.Ws_Child       or
                Win32.Winuser.Ws_Visible     or
                Win32.Winuser.Ws_Hscroll     or
                Win32.Winuser.Ws_Vscroll     or
                Win32.Winuser.Ws_Border      or
                Win32.Winuser.Es_Left        or
                Win32.Winuser.Es_Multiline   or
                Win32.Winuser.Es_Nohidesel   or
                Win32.Winuser.Es_Autohscroll or
                Win32.Winuser.Es_Autovscroll,
               X            => 
                0, 
               Y            => 
                0,
               Nwidth       => 
                0,
               Nheight      => 
                0,
               Hwndparent   => 
                Window_Handle,
               Hmenu        => 
                Convert_Int_To_Hmenu
                  (S =>
                    Edit_Id),
               Hinstance    => 
                Instance,
               Lpparam      => 
                null);

          L_Result :=
            Win32.Winuser.Sendmessage
              (Hwnd   =>
                Edit_Window_Handle,
               Msg    =>
                Win32.WInuser.Em_Limittext,
               Wparam =>
                32_000,
               Lparam =>
                0);

          Windows.Pop.File.Initialize
            (Window_Handle =>
              Window_Handle);
           
          Windows.Pop.File.Initialize
            (Window_Handle =>
              Edit_Window_Handle);
          
          Message_Find_Replace :=
            Win32.Winuser.Registerwindowmessage
              (Lpstring =>
                Convert_Address_To_Lpcstr
                  (S =>
                    Win32.Commdlg.Findmsgstring'Address));

          Pstr_Result :=
            Win32.Winbase.Lstrcpy
              (Lpstring1 =>
                Convert_Chars_Ptr_To_Lpstr
                  (S =>
                    File_Name),
               Lpstring2 =>
                Convert_Lpvoid_To_Lpcstr
                  (S =>
                    Convert_Lparam_To_Lpcreatestruct
                      (S =>
                        Lparam).Lpcreateparams));
        
          if
            Interfaces.C.Strings.Strlen
              (Item =>
                File_Name) > 0 then

            Short_Result :=
              Win32.Commdlg.Getfiletitle
                (Lpszfile  =>
                  Convert_Chars_Ptr_To_Lpcstr
                    (S =>
                      File_Name),
                 Lpsztitle =>
                  Convert_Chars_Ptr_To_Lpstr
                    (S =>
                      Title_Name),
                 Cbbuf     =>
                  Win32.Word
                    (Interfaces.C.Strings.Strlen
                      (Item =>
                        Title_Name)));

            if
              Windows.Pop.File.Read
                (Window_Handle =>
                  Edit_Window_Handle,
                 File_Name     =>
                  File_Name) = 
              False then

              Ok_Message
                (Window_Handle =>
                  Window_Handle,
                 Message       =>
                  "File Can not be opened file name is ",
                 Title_Name    =>
                  Title_Name);

            end if;

          end if;

          Do_Caption
            (Window_Handle =>
               Window_Handle,
             Title_Name    =>
               Title_Name);

          return (0);

        when
          Win32.Winuser.Wm_Setfocus =>
      
          Hwnd_Result :=
            Win32.Winuser.Setfocus
              (Hwnd =>
                Edit_Window_Handle);

          return (0);

        when
          Win32.Winuser.Wm_Size =>

          Bool_Result :=
            Win32.Winuser.Movewindow
              (Hwnd     =>
                Edit_Window_Handle,
               X        =>
                0,
               Y        =>
                0,
               Nwidth   =>
                Win32.Int
                  (Win32.Utils.Loword
                    (Win32.Dword
                      (Lparam))),
               Nheight  =>
                Win32.Int
                  (Win32.Utils.Hiword
                    (Win32.Dword
                      (Lparam))),
               Brepaint =>
                Win32.True);
      
          return (0);

        when
          Win32.Winuser.Wm_Initmenupopup  =>
      
          case 
            Lparam is
 
            when 
              1      =>

              L_Result :=
                Win32.Winuser.Sendmessage
                  (Hwnd   =>
                    Edit_Window_Handle,
                   Msg    =>
                    Win32.Winuser.Em_Canundo,
                   Wparam =>
                    0,
                   Lparam =>
                    0);

              if 
                L_Result /=
                0 then
               
                Bool_Result :=
                  Win32.Winuser.Enablemenuitem
                    (Hmenu         =>
                      Convert_Wparam_To_Hmenu
                        (S =>
                          Wparam),
                     Uidenableitem =>
                      Win32.Uint
                        (PopPad3.Idm_Undo),
                     Uenable       =>
                      Win32.Winuser.Mf_Enabled);

              else

                Bool_Result :=
                  Win32.Winuser.Enablemenuitem
                    (Hmenu         =>
                      Convert_Wparam_To_Hmenu
                        (S =>
                          Wparam),
                     Uidenableitem =>
                      Win32.Uint
                        (PopPad3.Idm_Undo),
                     Uenable       =>
                      Win32.Winuser.Mf_Grayed);

              end if;

              Bool_Result :=
                Win32.Winuser.Isclipboardformatavailable
                  (Format =>
                    Win32.Winuser.Cf_Text);

              if 
                Bool_Result /=
                Win32.False then
               
                Bool_Result :=
                  Win32.Winuser.Enablemenuitem
                    (Hmenu         =>
                      Convert_Wparam_To_Hmenu
                        (S =>
                          Wparam),
                     Uidenableitem =>
                      Win32.Uint
                        (PopPad3.Idm_Paste),
                     Uenable       =>
                      Win32.Winuser.Mf_Enabled);

              else

                Bool_Result :=
                  Win32.Winuser.Enablemenuitem
                    (Hmenu         =>
                      Convert_Wparam_To_Hmenu
                        (S =>
                          Wparam),
                     Uidenableitem =>
                      Win32.Uint
                        (PopPad3.Idm_Paste),
                     Uenable       =>
                      Win32.Winuser.Mf_Grayed);

              end if;
            
              L_Result :=
                Win32.Winuser.Sendmessage
                  (Hwnd   =>
                    Edit_Window_Handle,
                   Msg    =>
                    Win32.Winuser.Em_Getsel,
                   Wparam =>
                    Convert_Address_To_Wparam
                      (S => 
                        Begin_Select'Address)                    ,
                   Lparam =>
                    Convert_Address_To_Lparam
                      (S => 
                        End_Select'Address));

              if
                Begin_Select /=
                End_Select then

                Enabled :=
                  Win32.Winuser.Mf_Enabled;

              else

                Enabled :=
                  Win32.Winuser.Mf_Grayed;

              end if;

              Bool_Result :=
                Win32.Winuser.Enablemenuitem
                  (Hmenu         =>
                    Convert_Wparam_To_Hmenu
                      (S =>
                        Wparam),
                   Uidenableitem =>
                    Win32.Uint
                      (PopPad3.Idm_Cut),
                   Uenable       =>
                    Enabled);

              Bool_Result :=
                Win32.Winuser.Enablemenuitem
                  (Hmenu         =>
                    Convert_Wparam_To_Hmenu
                      (S =>
                        Wparam),
                   Uidenableitem =>
                    Win32.Uint
                      (PopPad3.Idm_Copy),
                   Uenable       =>
                    Enabled);

              Bool_Result :=
                Win32.Winuser.Enablemenuitem
                  (Hmenu         =>
                    Convert_Wparam_To_Hmenu
                      (S =>
                        Wparam),
                   Uidenableitem =>
                    Win32.Uint
                      (PopPad3.Idm_Clear),
                   Uenable       =>
                    Enabled);

            when 
              2      =>

              if
                Modeless_Dialog_Handle =
                null then

                Enabled :=
                  Win32.Winuser.Mf_Enabled;

              else

                Enabled :=
                  Win32.Winuser.Mf_Grayed;

              end if;

              Bool_Result :=
                Win32.Winuser.Enablemenuitem
                  (Hmenu         =>
                    Convert_Wparam_To_Hmenu
                      (S =>
                        Wparam),
                   Uidenableitem =>
                    Win32.Uint
                      (PopPad3.Idm_Find),
                   Uenable       =>
                    Enabled);

              Bool_Result :=
                Win32.Winuser.Enablemenuitem
                  (Hmenu         =>
                    Convert_Wparam_To_Hmenu
                      (S =>
                        Wparam),
                   Uidenableitem =>
                    Win32.Uint
                      (PopPad3.Idm_Next),
                   Uenable       =>
                    Enabled);

              Bool_Result :=
                Win32.Winuser.Enablemenuitem
                  (Hmenu         =>
                    Convert_Wparam_To_Hmenu
                      (S =>
                        Wparam),
                   Uidenableitem =>
                    Win32.Uint
                      (PopPad3.Idm_Replace),
                   Uenable       =>
                    Enabled);

            when 
              others =>
        
              null;

          end case;

          return (0);

        when
           Win32.Winuser.Wm_Command  =>
      
           if 
             Win32.Int
               (Lparam) =
             Edit_Id and
             Win32.Int
               (Win32.Utils.Loword
                 (Win32.Dword
                   (Wparam))) =
             Edit_Id then

             case 
               Win32.Int
                 (Win32.Utils.Hiword
                   (Win32.Dword
                     (Wparam))) is

                when
                  Win32.Winuser.En_Update   =>

                  Need_Save :=
                    Win32.True;

                  return
                    (0);
                
                when
                  Win32.Winuser.En_Errspace |
                  Win32.Winuser.En_Maxtext  =>
                
                  Integer_Result :=
                    Win32.Winuser.Messagebox
                      (Hwnd      =>
                        Window_Handle,
                       Lptext    =>
                        Convert_Chars_Ptr_To_Lpcstr
                          (S =>
                            Edit_Control_Text),
                       Lpcaption =>
                        Convert_Chars_Ptr_To_Lpcstr
                          (S =>
                            Windows.Data.Class_Name),
                       Utype     =>
                        Win32.Uint
                         (Win32.Winuser.Mb_Ok) or
                        Win32.Uint
                         (WIn32.Winuser.Mb_Iconstop));

                  return
                    (0);
                
                when
                  others                    =>
                
                  null;

             end case;

           end if;

           case 
             Win32.Int
               (Win32.Utils.Loword
                 (Win32.Dword
                   (Wparam))) is

             when
               Poppad3.Idm_New     =>
              
               Integer_Result :=
                 Ask_About_Save
                   (Window_Handle =>
                     Window_Handle,
                    Title_Name    =>
                     Title_Name);
               if 
                 Need_Save = 
                 Integer_Result and
                 Win32.Winuser.Idcancel = 
                 Integer_Result then

                 return
                   (0);

               end if;

               Bool_Result :=
                 Win32.Winuser.Setwindowtext
                   (Hwnd     =>
                     Edit_Window_Handle,
                    Lpstring =>
                     Convert_Chars_Ptr_To_Lpcstr
                       (S =>
                         Null_Text));
   
                 -- add stuff here

               Do_Caption
                 (Window_Handle =>
                   Window_Handle,
                  Title_Name    =>
                   Title_Name);

               Need_Save :=
                 Win32.False;
                 
               return
                 (0);

             when
               Poppad3.Idm_Open    =>
              
               Integer_Result :=
                 Ask_About_Save
                   (Window_Handle =>
                     Window_Handle,
                    Title_Name    =>
                     Title_Name);
               if 
                 Need_Save = 
                 Integer_Result and                                                             
                 Win32.Winuser.Idcancel = 
                 Integer_Result then

                 return
                   (0);

               end if;

               if
                 Windows.Pop.File.Open
                   (Window_Handle =>
                     Window_Handle,
                    File_Name     =>
                     File_Name,
                    Title_Name    =>
                     Title_Name) then
                    
                 if not
                   Windows.Pop.File.Read
                     (Window_Handle =>
                       Window_Handle,
                      File_Name     =>
                       File_Name) then

                   Ok_Message
                     (Window_Handle =>
                       Window_Handle,
                      Message       =>
                       "Could not read file",
                      Title_Name    =>
                       Title_Name);

                  --put stuff here

                 end if;  

               end if;

               Do_Caption
                 (Window_Handle =>
                   Window_Handle,
                  Title_Name    =>
                   Title_Name);

               Need_Save :=
                 Win32.False;
                 
               return
                 (0);

             when
               Poppad3.Idm_Save    =>
              
               if
                 Interfaces.C.Strings.Value
                   (Item =>
                     File_Name)(1) /= 
                 Character'Val(0) then

                 if
                   Windows.Pop.File.Write
                     (Window_Handle =>
                       Edit_Window_Handle,
                      File_Name     =>
                       File_Name) then
                 
                   Need_Save :=
                     Win32.False;

                   return
                     (1);

                 else
             
                   Ok_Message
                     (Window_Handle =>
                       Window_Handle,
                      Message       =>
                       "Could not write file",
                      Title_Name    =>
                       Title_Name);

                   return
                     (0);

                 end if;

               end if;

               if 
                 Windows.Pop.File.Save
                   (Window_Handle =>
                     Window_Handle,
                    File_Name     =>
                     File_Name,
                    Title_Name    =>
                     Title_Name) then

                 Do_Caption
                   (Window_Handle =>
                     Window_Handle,
                    Title_Name    =>
                     Title_Name);   
              
                 if 
                   Windows.Pop.File.Write
                     (Window_Handle =>
                       Edit_Window_Handle,
                      File_Name     =>
                       File_Name) then

                   Need_Save :=
                     Win32.False;

                   return
                     (1);

                 else

                   Ok_Message
                     (Window_Handle =>
                       Window_Handle,
                      Message       =>
                       "Could not write file",
                      Title_Name    =>
                       Title_Name);
                      
                 end if;

               end if;
              
               return
                 (0);

             when
               Poppad3.Idm_Saveas  =>

               if 
                 Windows.Pop.File.Save
                   (Window_Handle =>
                     Window_Handle,
                    File_Name     =>
                     File_Name,
                    Title_Name    =>
                     Title_Name) then

                 Do_Caption
                   (Window_Handle =>
                     Window_Handle,
                    Title_Name    =>
                     Title_Name);   
              
                 if 
                   Windows.Pop.File.Write
                     (Window_Handle =>
                       Edit_Window_Handle,
                      File_Name     =>
                       File_Name) then

                   Need_Save :=
                     Win32.False;

                   return
                     (1);

                 else

                   Ok_Message
                     (Window_Handle =>
                       Window_Handle,
                      Message       =>
                       "Could not write file",
                      Title_Name    =>
                       Title_Name);
                      
                 end if;

               end if;
              
               return
                 (0);

             when
               Poppad3.Idm_Print   =>
              
               If not
                 Windows.Pop.Print.File
                   (Instance           =>
                     Instance,
                    Window_Handle      =>
                     Window_Handle,
                    Edit_Window_Handle =>
                     Edit_Window_Handle,
                    Name               =>
                     Title_Name) then
                 
                 Ok_Message
                   (Window_Handle =>
                     Window_Handle,
                    Message       =>
                     "Could not print file",
                    Title_Name    =>
                     Title_Name);

               end if;

               return 
                 (0);

             when
               Poppad3.Idm_Exit    =>
              
               L_Result :=
                 Win32.Winuser.Sendmessage
                   (Hwnd   =>
                     Window_Handle,
                    Msg    =>
                     Win32.Winuser.Wm_Close,
                    Wparam =>
                     0,
                    Lparam =>
                     0);

               return
                 (0);

             when
               Poppad3.Idm_Undo    =>
              
               L_Result :=
                 Win32.Winuser.Sendmessage
                   (Hwnd   =>
                     Edit_Window_Handle,
                    Msg    =>
                     Win32.Winuser.Wm_Undo,
                    Wparam =>
                     0,
                    Lparam =>
                     0);

               return
                 (0);

             when
               Poppad3.Idm_Cut     =>
              
               L_Result :=
                 Win32.Winuser.Sendmessage
                   (Hwnd   =>
                     Edit_Window_Handle,
                    Msg    =>
                     Win32.Winuser.Wm_Cut,
                    Wparam =>
                     0,
                    Lparam =>
                     0);

               return
                 (0);

             when
               Poppad3.Idm_Copy    =>
              
               L_Result :=
                 Win32.Winuser.Sendmessage
                   (Hwnd   =>
                     Edit_Window_Handle,
                    Msg    =>
                     Win32.Winuser.Wm_Copy,
                    Wparam =>
                     0,
                    Lparam =>
                     0);

               return
                 (0);

             when
               Poppad3.Idm_Paste   =>
              
               L_Result :=
                 Win32.Winuser.Sendmessage
                   (Hwnd   =>
                     Edit_Window_Handle,
                    Msg    =>
                     Win32.Winuser.Wm_Paste,
                    Wparam =>
                     0,
                    Lparam =>
                     0);

               return
                 (0);

             when
               Poppad3.Idm_Clear   =>
              
               L_Result :=
                 Win32.Winuser.Sendmessage
                   (Hwnd   =>
                     Edit_Window_Handle,
                    Msg    =>
                     Win32.Winuser.Wm_Clear,
                    Wparam =>
                     0,
                    Lparam =>
                     0);

               return
                 (0);

             when
               Poppad3.Idm_Selall  =>
              
               L_Result :=
                 Win32.Winuser.Sendmessage
                   (Hwnd   =>
                     Edit_Window_Handle,
                    Msg    =>
                     Win32.Winuser.Em_Setsel,
                    Wparam =>
                     0,
                    Lparam =>
                     -1);

               return
                 (0);

             when
               Poppad3.Idm_Find    =>
              
               L_Result :=
                 Win32.Winuser.Sendmessage
                   (Hwnd   =>
                     Edit_Window_Handle,
                    Msg    =>
                     Win32.Winuser.Em_Getsel,
                    Wparam =>
                     0,
                    Lparam =>
                     Convert_Int_Ptr_To_LParam
                       (S => 
                         Offset));

               Modeless_Dialog_Handle :=
                 Windows.Pop.Find.Find_Dialog
                   (Window_Handle =>
                     Window_Handle);

               return
                 (0);

             when
               Poppad3.Idm_Next    =>
              
               L_Result :=
                 Win32.Winuser.Sendmessage
                   (Hwnd   =>
                     Edit_Window_Handle,
                    Msg    =>
                     Win32.Winuser.Em_Getsel,
                    Wparam =>
                     0,
                    Lparam =>
                     Convert_Int_Ptr_To_LParam
                       (S => 
                         Offset));
               
               if
                 Windows.Pop.Find.Valid then

                 Boolean_Result :=
                   Windows.Pop.Find.Next_Text
                     (Window_Handle =>
                       Window_Handle,
                      Search_Offset =>
                       Offset);
               else

                 Modeless_Dialog_Handle :=
                   Windows.Pop.Find.Find_Dialog
                     (Window_Handle =>
                       Window_Handle);

               end if;

               return
                 (0);

             when
               Poppad3.Idm_Replace =>
              
               L_Result :=
                 Win32.Winuser.Sendmessage
                   (Hwnd   =>
                     Edit_Window_Handle,
                    Msg    =>
                     Win32.Winuser.Em_Getsel,
                    Wparam =>
                     0,
                    Lparam =>
                     Convert_Int_Ptr_To_LParam
                       (S => 
                         Offset));

               Modeless_Dialog_Handle :=
                 Windows.Pop.Find.Replace_Dialog
                   (Window_Handle =>
                     Window_Handle);

               return
                 (0);

             when
               Poppad3.Idm_Font    =>
              
               if
                 Windows.Pop.Font.Choose
                   (Window_Handle =>
                     Window_Handle) then
                
                  Windows.Pop.Font.Set
                   (Window_Handle =>
                     Window_Handle);

               end if;

               return
                 (0);

             when
               Poppad3.Idm_Help    =>
              
               Ok_Message
                 (Window_Handle =>
                   Window_Handle,
                  Message       =>
                   "Help not yet implemented!",
                  Title_Name    =>
                   Null_Text);

               return
                 (0);

             when
               Poppad3.Idm_About   =>
              
               Integer_Result :=
                 Win32.Winuser.Dialogbox
                   (Hinstance      =>
                     Instance,
                    Lptemplatename =>
                     Convert_Chars_Ptr_To_Lpcstr
                       (S =>
                         About_Text),
                    Hwndparent     =>
                     Window_Handle,
                    Lpdialogfunc   =>
                     Windows.Child_Routines.About_Dialog'Access);

               return
                 (0);

             when
               others =>
           
               null;

           end case;

           return
             (0);

	     when
           Win32.Winuser.Wm_Close   =>

           Integer_Result :=
             Ask_About_Save
               (Window_Handle =>
                 Window_Handle,
                Title_Name    =>
                 Title_Name);

           if 
             Need_Save = 
             Integer_Result and                                                             
             Win32.Winuser.Idcancel = 
             Integer_Result then

             Bool_Result :=
               Win32.Winuser.Destroywindow
                 (Hwnd =>
                   Window_Handle);

           end if;

           return
             (0);

	     when
           Win32.Winuser.Wm_Queryendsession =>

           Integer_Result :=
             Ask_About_Save
               (Window_Handle =>
                 Window_Handle,
                Title_Name    =>
                 Title_Name);

           if 
             Need_Save = 
             Integer_Result and                                                             
             Win32.Winuser.Idcancel = 
             Integer_Result then

             Bool_Result :=
               Win32.Winuser.Destroywindow
                 (Hwnd =>
                   Window_Handle);

           end if;

           return
             (1);

        when
          Win32.WinUser.Wm_Destroy =>

          Windows.Pop.Font.Uninitialize;

          Win32.WinUser.Postquitmessage
            (Nexitcode => 
              0);

	      return (0);

	 when
           others =>

	   return
             Win32.Winuser.Defwindowproc
	       (Hwnd   =>
                 Window_Handle, 
	        Msg    => 
                 Message, 
	        Wparam => 
                 Wparam,
	        Lparam => 
                 Lparam);

      end case;

      return (0);

   end Main_Windows;

end Windows.Routines;
