-- Filename: clover.ads
--
-- This is the conversion of Petzold's Win 95
-- Chapter 4 program clover.  This file contains
-- the data structures needed for this program.
-- 
with Ada.Numerics;
with System;

with Win32;
with Win32.Windef;

use type Win32.Char_Array;

package Clover is

   Two_Pi     : constant float := 2.0 * Ada.Numerics.Pi;
   One_Degree : constant float := Two_Pi / 360.0;

   Client_Width  : Win32.Int;
   Client_Height : Win32.Int;

   Handle_Clip_Region : Win32.Windef.Hrgn := System.Null_Address;

end Clover;
