-- Filename: scramble.ads
--
-- This is the conversion of Petzold's Win 95
-- Chapter 4 program scramble.  This file contains
-- the data structures needed for this program.
-- 
with Ada.Numerics.Discrete_Random;
with System;

with Win32;
with Win32.Wingdi;

use type Win32.Char_Array;
use type Win32.Int;

package scramble is

   Screen_Width  : Win32.Int;
   Screen_Height : Win32.Int;

   Driver_Name : constant Win32.Char_Array := "DISPLAY" & win32.Nul;

   Num : constant Win32.Int := 200;

   type IKeep_Type is array (0..NUM-1, 0..3) of Win32.Int;
   IKeep : IKeep_Type;

   package Random_Win32Int is new Ada.Numerics.Discrete_Random (Win32.Int);
   Gen : Random_Win32Int.Generator;

end scramble;
