with Interfaces.C.Strings;
with Win32;
package System_Metrics is
   use type Win32.Char_Array;

   type Sm is
      (Cxscreen,
       Cyscreen,
       Cxvscroll,
       Cyhscroll,
       Cycaption,
       Cxborder,
       Cyborder,
       Cxdlgframe,
       Cydlgframe,
       Cyvthumb,
       Cxhthumb,
       Cxicon,
       Cyicon,
       Cxcursor,
       Cycursor,
       Cymenu,
       Cxfullscreen,
       Cyfullscreen,
       Cykanjiwindow,
       Mousepresent,
       Cyvscroll,
       Cxhscroll,
       Debug,
       Swapbutton,
       Reserved1,
       Reserved2,
       Reserved3,
       Reserved4,
       Cxmin,
       Cymin,
       Cxsize,
       Cysize,
       Cxframe,
       Cyframe,
       Cxmintrack,
       Cymintrack,
       Cxdoubleclk,
       Cydoubleclk,
       Cxiconspacing,
       Cyiconspacing,
       Menudropalignment,
       Penwindows,
       Dbcsenabled,
       Cmousebuttons,
       Secure,
       Cxedge,
       Cyedge,
       Cxminspacing,
       Cyminspacing,
       Cxsmicon,
       Cysmicon,
       Cysmcaption,
       Cxsmsize,
       Cysmsize,
       Cxmenusize,
       Cymenusize,
       Arrange,
       Cxminimized,
       Cyminimized,
       Cxmaxtrack,
       Cymaxtrack,
       Cxmaximized,
       Cymaximized,
       Network,
       Cleanboot,
       Cxdrag,
       Cydrag,
       Showsounds,
       Cxmenucheck,
       Cymenucheck,
       Slowmachine,
       Mideastenabled,
       Cmetrics);

   for Sm use
      (Cxscreen          =>  0,
       Cyscreen          =>  1,
       Cxvscroll         =>  2,
       Cyhscroll         =>  3,
       Cycaption         =>  4,
       Cxborder          =>  5,
       Cyborder          =>  6,
       Cxdlgframe        =>  7,
       Cydlgframe        =>  8,
       Cyvthumb          =>  9,
       Cxhthumb          => 10,
       Cxicon            => 11,
       Cyicon            => 12,
       Cxcursor          => 13,
       Cycursor          => 14,
       Cymenu            => 15,
       Cxfullscreen      => 16,
       Cyfullscreen      => 17,
       Cykanjiwindow     => 18,
       Mousepresent      => 19,
       Cyvscroll         => 20,
       Cxhscroll         => 21,
       Debug             => 22,
       Swapbutton        => 23,
       Reserved1         => 24,
       Reserved2         => 25,
       Reserved3         => 26,
       Reserved4         => 27,
       Cxmin             => 28,
       Cymin             => 29,
       Cxsize            => 30,
       Cysize            => 31,
       Cxframe           => 32,
       Cyframe           => 33,
       Cxmintrack        => 34,
       Cymintrack        => 35,
       Cxdoubleclk       => 36,
       Cydoubleclk       => 37,
       Cxiconspacing     => 38,
       Cyiconspacing     => 39,
       Menudropalignment => 40,
       Penwindows        => 41,
       Dbcsenabled       => 42,
       Cmousebuttons     => 43,
       Secure            => 44,
       Cxedge            => 45,
       Cyedge            => 46,
       Cxminspacing      => 47,
       Cyminspacing      => 48,
       Cxsmicon          => 49,
       Cysmicon          => 50,
       Cysmcaption       => 51,
       Cxsmsize          => 52,
       Cysmsize          => 53,
       Cxmenusize        => 54,
       Cymenusize        => 55,
       Arrange           => 56,
       Cxminimized       => 57,
       Cyminimized       => 58,
       Cxmaxtrack        => 59,
       Cymaxtrack        => 60,
       Cxmaximized       => 61,
       Cymaximized       => 62,
       Network           => 63,
       Cleanboot         => 67,
       Cxdrag            => 68,
       Cydrag            => 69,
       Showsounds        => 70,
       Cxmenucheck       => 71,
       Cymenucheck       => 72,
       Slowmachine       => 73,
       Mideastenabled    => 74,
       Cmetrics           => 75);


   Cxfixedframe : constant Sm := Cxdlgframe;
   Cyfixedframe : constant Sm := Cydlgframe;
   Cxsizeframe  : constant Sm := Cxframe;
   Cysizeframe  : constant Sm := Cyframe;

   type Sm_Record is
      record
	 Label       : Interfaces.C.Strings.Chars_Ptr;
	 Description : Interfaces.C.Strings.Chars_Ptr;
      end record;

   type Sm_Record_Array is array ( Sm'First .. Sm'Last ) of Sm_Record;

   Metrics_Record_Array : constant Sm_Record_Array :=
     (Cyscreen         => 
	(Label              => 
	   Interfaces.C.Strings.New_String
	 (Str =>"SM_CYSCREEN"),
	 Description        => 
	   Interfaces.C.Strings.New_String
	 (Str => "Screen width in pixels")),
      Cxscreen         => 
	(Label              => 
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXSCREEN"),
	 Description        => 
	   Interfaces.C.Strings.New_String
	 (Str => "Screen height in pixels")),
      Cxvscroll        => 
        (Label              => 
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXVSCROLL"),
         Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Vertical scroll arrow width")),
      Cyhscroll        => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYHSCROLL"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Horizontal scroll arrow width")),
      Cycaption        => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYCAPTION"),
	 Description        =>         
	   Interfaces.C.Strings.New_String
	 (Str => "Caption bar height")),
      Cxborder         => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXBORDER"),
	 Description        =>         
	   Interfaces.C.Strings.New_String
	  (Str => "Window border width")),
      Cyborder         => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYBORDER"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Window border height")),
      Cxdlgframe       => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXDLGFRAME"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Dialog window frame width")),
      Cydlgframe       => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYDLGFRAME"),
	 Description        =>         
	   Interfaces.C.Strings.New_String
	  (Str => "Dialog window frame height")),
      Cyvthumb         => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYVTHUMB"),
	 Description        =>          
	  Interfaces.C.Strings.New_String
	 (Str => "Vertical scroll thumb height")),
      Cxhthumb         => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXHTHUMB"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Vertical scroll thumb width")),
      Cxicon           => 
	 (Label              =>          
	    Interfaces.C.Strings.New_String
	  (Str => "SM_CXICON"),
	   Description        =>          
	    Interfaces.C.Strings.New_String
	  (Str => "Icon width")),
      Cyicon           => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYICON"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Icon height")),
      Cxcursor         => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXCURSOR"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Cursor width")),
      Cycursor         => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYCURSOR"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Cursor height")),
      Cymenu           => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYMENU"),
	 Description        =>          
	 Interfaces.C.Strings.New_String
	 (Str => "Menu bar height")),
      Cxfullscreen     =>
	(Label              =>          
	    Interfaces.C.Strings.New_String
	  (Str => "SM_CXFULLSCREEN"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Full screen client area width")),
      Cyfullscreen     => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYFULLSCREEN"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Full screen client area height")),
     Cykanjiwindow     => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYKANJIWINDOW"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Kanji window height")),
     Mousepresent      => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_MOUSEPRESENT"),
	 Description        =>          
	 Interfaces.C.Strings.New_String
	 (Str => "Mouse present flag")),
     Cyvscroll         => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYVSCROLL"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "Vertical scroll arrow height")),
     Cxhscroll         => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXHSCROLL"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "Horizontal scroll arrow width")),
     Debug             => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_DEBUG"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "Debug version flag")),
     Swapbutton        => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_SWAPBUTTON"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "Mouse Button swapped flag")),
     Reserved1         => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_RESERVED1"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "Reserved number 1")),
     Reserved2         => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_RESERVED2"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "Reserved number 2")),
     Reserved3         => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_RESERVED3"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Reserved number 3")),
     Reserved4         => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_RESERVED4"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "Reserved number 4")),
     Cxmin             => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXMIN"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "Minimum window width")),
     Cymin             => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYMIN"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Minimum window height")),
     Cxsize            => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXSIZE"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Minimize/Maximize icon width")),
     Cysize            => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYSIZE"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Minimize/Maximize icon height")),
     Cxframe           => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXFRAME"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Window frame width")),
     Cyframe           => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYFRAME"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Window frame height")),
     Cxmintrack        => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXMINTRACK"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Minimum window tracking width")),
     Cymintrack        => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYMINTRACK"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Minimum window tracking height")),
     Cxdoubleclk       => 
       (Label              =>          
	 Interfaces.C.Strings.New_String
	(Str => "SM_CXDOUBLECLK"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Double click x tolerance")),
     Cydoubleclk       => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYDOUBLECLK"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Double click y tolerance")),
     Cxiconspacing     => 
	 (Label              =>          
	    Interfaces.C.Strings.New_String
	  (Str => "SM_CXICONSPACING"),
	  Description        =>          
	    Interfaces.C.Strings.New_String
	  (Str => "Horizontal icon spacing")),
     Cyiconspacing     => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYICONSPACING"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Vertical icon spacing")),
     Menudropalignment => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_MENUDROPALIGNMENT"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "Left or right menu drop")),
     Penwindows        => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_PENWINDOWS"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "Pen extensions installed")),
     Dbcsenabled       => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_DBCSENABLED"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Double-Byte Char Set enabled")),
     Cmousebuttons     => 
       (Label              =>
	  Interfaces.C.Strings.New_String
	(Str => "SM_CMOUSEBUTTONS"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "Number of mouse buttons")),
     Secure            => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_SECURE"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_SECURE")),
     Cxedge            => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXEDGE"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXEDGE")),
     Cyedge            => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYEDGE"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "SM_CYEDGE")),
     Cxminspacing      => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXMINSPACING"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXMINSPACING")),
     Cyminspacing      => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYMINSPACING"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYMINSPACING")),
     Cxsmicon          => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXSMICON"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXSMICON")),
     Cysmicon          => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYSMICON"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYSMICON")),
     Cysmcaption       => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYSMCAPTION"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CYSMCAPTION")),
     Cxsmsize          => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CXSMSIZE"),
	Description        =>          
	 Interfaces.C.Strings.New_String
	(Str => "SM_CXSMSIZE")),
      Cysmsize         => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYSMSIZE"),
	 Description        =>          
	  Interfaces.C.Strings.New_String
	 (Str => "SM_CYSMSIZE")),
      Cxmenusize       => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXMENUSIZE"),
	 Description        =>          
	  Interfaces.C.Strings.New_String
	 (Str => "SM_CXMENUSIZE")),
      Cymenusize       => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYMENUSIZE"),
	 Description        =>          
	  Interfaces.C.Strings.New_String
	 (Str => "SM_CYMENUSIZE")),
      Arrange          => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_ARRANGE"),
	 Description        =>          
	  Interfaces.C.Strings.New_String
	 (Str => "SM_ARRANGE")),
      Cxminimized      => 
	(Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXMINIMIZED"),
	 Description        =>          
	  Interfaces.C.Strings.New_String
	 (Str => "SM_CXMINIMIZED")),
      Cyminimized      => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYMINIMIZED"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYMINIMIZED")),
      Cxmaxtrack       => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXMAXTRACK"),
	  Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXMAXTRACK")),
      Cymaxtrack       => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYMAXTRACK"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYMAXTRACK")),
      Cxmaximized      => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	  (Str => "SM_CXMAXIMIZED"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXMAXIMIZED")),
      Cymaximized      => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYMAXIMIZED"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYMAXIMIZED")),
      Network          => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	  (Str => "SM_NETWORK"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_NETWORK")),
      Cleanboot        => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CLEANBOOT"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CLEANBOOT")),
      Cxdrag           => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXDRAG"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXDRAG")),
      Cydrag           => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYDRAG"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
           (Str => "SM_CYDRAG")),
      Showsounds       => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_SHOWSOUNDS"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "Present sound visually")),
      Cxmenucheck      => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXMENUCHECK"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CXMENUCHECK")),
      Cymenucheck      => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYMENUCHECK"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_CYMENUCHECK")),
      Slowmachine      => 
        (Label              =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_SLOWMACHINE"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_SLOWMACHINE")),
      Mideastenabled   => 
        (Label =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_MIDEASTENABLED"),
	 Description        =>          
	   Interfaces.C.Strings.New_String
	 (Str => "SM_MIDEASTENABLED")),
      Cmetrics         => 
       (Label              =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CMETRICS"),
	Description        =>          
	  Interfaces.C.Strings.New_String
	(Str => "SM_CMETRICS")));
   
end System_Metrics;










